/*******************************************************************************
 Newton-Raphson search method

 many thanks to http://generactive.net/tools/pde_to_pjs/convert_to_pjs.html?#

 $Author: dmc $ 
 $Revision: 3192 $
 $Date: 2023-05-02 09:15:20 -0300 (Tue, 02 May 2023) $
 $HeadURL: http://support2.silvermountaintargets.com/svn/smt/smt.common.lib/calc_shot_nr.js $
*******************************************************************************/

var mic_mapping = require('./mic_mapping.js');
var nr_calcs = require('./nr_calcs.js');


// DMC notes:

// globals:
// NOTANYMORE mic_pos = array of XYZ
// mic_n = # mics
// clock = counts (16000) per time unit (ms)
// v_sound = soundspeed, mm/ms



// globals

var effingmm_to_cm = 1; // 0.1;
var effingcm_to_mm = 10;



//var mic_pos =  []; // will be filled in by solve_nr
var mic_n =  0;
var clock;// =  160000; // GD cms....!!!
var clock =  16000/effingmm_to_cm; // GD cms....!!!
// var v_sound;

var shot_n = 1; // set to 1 for debugging messages, otherwise it doesn't do much really...???
var traceflag = 0*1 + 0*2 + 0*4;
//var traceflag = 1*1 + 1*2 + 1*4;


$p={};
$p.extendClassChain = function(){};

//$p.addMethod($this_1, 'dist', dist$1, false);
$p.addMethod = function(t,nm,method_fn,ff) {
	//console.log("$p.addMethod(",t,nm,method_fn,ff,")")
	t[nm]=method_fn; // note: needs more work; e.g. XYZ.norm() does not work
}

// e.g. $this_1.mic =  $p.createJavaArray('double', [mic_n]);
$p.createJavaArray = function(typename/*ignored*/, sizearr) {
	var sz = sizearr[0];
	if (sz < 2) arr = [];
	else arr = new Array(sz);
	return arr;
};

$p.println = function(text) {
	console.log("PRINTLN:",text);
}

function trim_num(nn,ndigs) {
	if (typeof ndigs == 'undefined' || ndigs < 0 || ndigs > 5) ndigs = 0;
	if (typeof nn == 'number') return +nn.toFixed(ndigs); // '+' needed to return 'number' not 'string'
	return nn;
}



/// file marcsearch.pde



var Params = (function() {
	function Params() {
		var $this_1 = this;
		function $superCstr(){$p.extendClassChain($this_1)}
		$this_1.p1 = null;
		$this_1.p2 = null;
		$this_1.p3 = null;
		$this_1.p4 = null;
		$this_1.p5 = null;
		$this_1.p6 = null;
		function copyFrom$1(p) {
			$this_1.p1 = p.p1;
			$this_1.p2 = p.p2;
			$this_1.p3 = p.p3;
			$this_1.p4 = p.p4;
			$this_1.p5 = p.p5;
			$this_1.p6 = p.p6;
		}
		$p.addMethod($this_1, 'copyFrom', copyFrom$1, false);

		function $constr() { $superCstr(); }
		$constr.apply(null, arguments);
	}
	return Params;
})();
$p.Params = Params;


var Derivatives = function() {
  this.o = [0,0,0,0,0,0];
  this.p1 = [0,0,0,0,0,0];
  this.p2 = [0,0,0,0,0,0];
  this.p3 = [0,0,0,0,0,0];
  this.p4 = [0,0,0,0,0,0];
  this.p5 = [0,0,0,0,0,0];
  this.p6 = [0,0,0,0,0,0];
  

};

/*
  double o[] = new double[6];
  double p1[] = new double[6];
  double p2[] = new double[6];
  double p3[] = new double[6];
  double p4[] = new double[6];
  double p5[] = new double[6];
  double p6[] = new double[6];
*/

// //DMC  function compute(s, timings, n_params, perm, mic_pos) {
//   function marcsearch_compute(s, timings, n_params, perm, mic_pos) {

//     var mx=[], my=[], mz=[], t=[]; // DMC
//     var Pt0 =  new Params();    var Pt =  new Params();    var Pt1 =  new Params();  // DMC
//     var Dt =  new Derivatives(); // DMC
//     var soln_status = true; // will set to false, if anything invalidates the solution

//     Pt0.p1 = s.pos.x;
//     Pt0.p2 = s.pos.y;
//     Pt0.p3 = s.t0;
//     Pt0.p4 = s.vel / clock;
//     Pt0.p5 = s.theta;
//     Pt0.p6 = s.phi;

// //console.log("DMC marcsearch_compute n_params=",n_params,"timings=",timings,"perm=",perm);
// //console.log("DMC marcsearch_compute Dt",Dt);
// //console.log("DMC marcsearch_compute Pt0",Pt0);
//          Pt.copyFrom(Pt0);
// //console.log("DMC marcsearch_compute Pt",Pt);

//     va = v_sound / clock;
// //    $p.println("va = " + va+" v_sound="+v_sound);
    
//     for (var j =  0;  j < n_params;  j++) {
//       var i =  perm[j];
//       mx[j] = mic_pos[i].x;
//       my[j] = mic_pos[i].y;
//       mz[j] = mic_pos[i].z;
//       t[j] = timings[i];
//       if (t[j] == -1) {
//         soln_status = false; // if we are missing a mic timing, this solution is invalid
//       }
//       if ((traceflag&1)!=0 && shot_n == 1) $p.println("mic " + (j+1) + ", t = " + t[j]+" posn="+mic_pos[i].toString());
//     }
// //console.log("DMC marcsearch_compute t=",t,"mics=",perm);

//     if ((traceflag&2)!=0 && shot_n == 1) {
// $p.println("marc search initial guess:");
// //console.log("DMC: s=",s);
// //process.exit(1);
//       $p.println(" x0 = " + Pt.p1);
//       $p.println(" y0 = " + Pt.p2);
//       $p.println(" t0 = " + Pt.p3);
//       $p.println(" vb = " + Pt.p4 * clock);
//       $p.println(" sa = " + Pt.p5);
//       $p.println(" pa = " + Pt.p6);
//       $p.println("-------------------------------");
//     }

//     var error =  500; // in original code, this is in cms.

//     var max_iters =  50;
//     var count = 0;
//     for (count = 0;  soln_status && count < max_iters && error > 0.1*effingcm_to_mm;  count++) {
//       for (var i =  0;  i < n_params;  i++) {
//         Dt.o[i] = $p.pow($p.cos(Pt.p5)*(Pt.p1 - mx[i]) + mz[i]*$p.sin(Pt.p5),2) + $p.pow($p.cos(Pt.p6)*(-Pt.p2 + my[i]) + $p.sin(Pt.p6)*($p.cos(Pt.p5)*mz[i] + (-Pt.p1 + mx[i])*$p.sin(Pt.p5)),2) - $p.pow((Pt.p2 - my[i])*$p.sin(Pt.p6) + $p.cos(Pt.p6)*($p.cos(Pt.p5)*mz[i] + (-Pt.p1 + mx[i])*$p.sin(Pt.p5)) + Pt.p4*(Pt.p3 + t[i]),2)/(-1 + $p.pow(Pt.p4,2)/$p.pow(va,2));
//         if (n_params >= 1) Dt.p1[i] = 2*$p.cos(Pt.p5)*($p.cos(Pt.p5)*(Pt.p1 - mx[i]) + mz[i]*$p.sin(Pt.p5)) - 2*$p.sin(Pt.p6)*$p.sin(Pt.p5)*($p.cos(Pt.p6)*(-Pt.p2 + my[i]) + $p.sin(Pt.p6)*($p.cos(Pt.p5)*mz[i] + (-Pt.p1 + mx[i])*$p.sin(Pt.p5))) + (2*$p.cos(Pt.p6)*$p.sin(Pt.p5)*((Pt.p2 - my[i])*$p.sin(Pt.p6) + $p.cos(Pt.p6)*($p.cos(Pt.p5)*mz[i] + (-Pt.p1 + mx[i])*$p.sin(Pt.p5)) + Pt.p4*(Pt.p3 + t[i])))/(-1 + $p.pow(Pt.p4,2)/$p.pow(va,2));
//         if (n_params >= 2) Dt.p2[i] = (2*(($p.pow(va,2) - $p.pow(Pt.p4,2))*$p.pow($p.cos(Pt.p6),2)*(Pt.p2 - my[i]) + $p.pow(Pt.p4,2)*$p.cos(Pt.p6)*$p.sin(Pt.p6)*($p.cos(Pt.p5)*mz[i] + (-Pt.p1 + mx[i])*$p.sin(Pt.p5)) + $p.pow(va,2)*$p.sin(Pt.p6)*((Pt.p2 - my[i])*$p.sin(Pt.p6) + Pt.p4*(Pt.p3 + t[i]))))/($p.pow(va,2) - $p.pow(Pt.p4,2));
//         if (n_params >= 3) Dt.p3[i] = (-2*Pt.p4*((Pt.p2 - my[i])*$p.sin(Pt.p6) + $p.cos(Pt.p6)*($p.cos(Pt.p5)*mz[i] + (-Pt.p1 + mx[i])*$p.sin(Pt.p5)) + Pt.p4*(Pt.p3 + t[i])))/(-1 + $p.pow(Pt.p4,2)/$p.pow(va,2));
//         if (n_params >= 4) Dt.p4[i] = (2*$p.pow(va,2)*(Pt.p4*(Pt.p2 - my[i])*$p.sin(Pt.p6) + Pt.p4*$p.cos(Pt.p6)*($p.cos(Pt.p5)*mz[i] + (-Pt.p1 + mx[i])*$p.sin(Pt.p5)) + $p.pow(va,2)*(Pt.p3 + t[i]))*((Pt.p2 - my[i])*$p.sin(Pt.p6) + $p.cos(Pt.p6)*($p.cos(Pt.p5)*mz[i] + (-Pt.p1 + mx[i])*$p.sin(Pt.p5)) + Pt.p4*(Pt.p3 + t[i])))/$p.pow($p.pow(va,2) - $p.pow(Pt.p4,2),2);
//         if (n_params >= 5) Dt.p5[i] = (2*Pt.p4*$p.cos(Pt.p6)*($p.cos(Pt.p5)*(Pt.p1 - mx[i]) + mz[i]*$p.sin(Pt.p5))*(Pt.p4*(Pt.p2 - my[i])*$p.sin(Pt.p6) + Pt.p4*$p.cos(Pt.p6)*($p.cos(Pt.p5)*mz[i] + (-Pt.p1 + mx[i])*$p.sin(Pt.p5)) + $p.pow(va,2)*(Pt.p3 + t[i])))/(-$p.pow(va,2) + $p.pow(Pt.p4,2));
//         if (n_params >= 6) Dt.p6[i] = (-2*Pt.p4*($p.cos(Pt.p6)*(Pt.p2 - my[i]) - $p.sin(Pt.p6)*($p.cos(Pt.p5)*mz[i] + (-Pt.p1 + mx[i])*$p.sin(Pt.p5)))*(Pt.p4*(Pt.p2 - my[i])*$p.sin(Pt.p6) + Pt.p4*$p.cos(Pt.p6)*($p.cos(Pt.p5)*mz[i] + (-Pt.p1 + mx[i])*$p.sin(Pt.p5)) + $p.pow(va,2)*(Pt.p3 + t[i])))/(-$p.pow(va,2) + $p.pow(Pt.p4,2));

// //        $p.println("Dt[" + i + "] = [" + Dt.o[i] + ", " + Dt.p1[i] + ", " + Dt.p2[i] + ", " + Dt.p4[i] + ", " + Dt.p3[i] + ", " + Dt.p5[i] + ", " + Dt.p6[i] + "]");

//       }

// //console.log("DMC marcsearch_compute count=",count," n_params=",n_params/*," Dt.o[0]=",Dt.o[0]," Dt=",Dt*/);


//       if (n_params == 3) {
//         Pt1.p1 = nr_calcs.compute_p11o3(Pt, Dt);
// //$p.println("Pt= " + Pt.p1 + ", " + Pt.p2 + ", " + Pt.p4 + ", " + Pt.p3 + ", " + Pt.p5 + ", " + Pt.p6);
// //$p.println("Pt1= " + Pt1.p1 + ", " + Pt1.p2 + ", " + Pt1.p4 + ", " + Pt1.p3 + ", " + Pt1.p5 + ", " + Pt1.p6);

//         Pt1.p2 = nr_calcs.compute_p21o3(Pt, Dt);
//         Pt1.p3 = nr_calcs.compute_p31o3(Pt, Dt);
//         Pt1.p4 = Pt.p4;
//         Pt1.p5 = Pt.p5;
//         Pt1.p6 = Pt.p6;
// //console.log("DMC ===> Pt1=",Pt1);
//       } else if (n_params == 5) {
//         Pt1.p1 = nr_calcs.compute_p11o5(Pt, Dt);
//         Pt1.p2 = nr_calcs.compute_p21o5(Pt, Dt);
//         Pt1.p3 = nr_calcs.compute_p31o5(Pt, Dt);
//         Pt1.p4 = nr_calcs.compute_p41o5(Pt, Dt);
//         Pt1.p5 = nr_calcs.compute_p51o5(Pt, Dt);
//         Pt1.p6 = Pt.p6;
//       } else if (n_params == 6) {
//         Pt1.p1 = nr_calcs.compute_p11o6(Pt, Dt);
//         Pt1.p2 = nr_calcs.compute_p21o6(Pt, Dt);
//         Pt1.p3 = nr_calcs.compute_p31o6(Pt, Dt);
//         Pt1.p4 = nr_calcs.compute_p41o6(Pt, Dt);
//         Pt1.p5 = nr_calcs.compute_p51o6(Pt, Dt);
//         Pt1.p6 = nr_calcs.compute_p61o6(Pt, Dt);
//       }

//       error = $p.sqrt((Pt.p1 - Pt1.p1) * (Pt.p1 - Pt1.p1) + (Pt.p2 - Pt1.p2) * (Pt.p2 - Pt1.p2));
//       Pt.copyFrom(Pt1);

//       if ((traceflag&4)!=0 && shot_n == 1) {
//         $p.println(" x0 = " + Pt.p1);
//         $p.println(" y0 = " + Pt.p2);
//         $p.println(" t0 = " + Pt.p3);
//         $p.println(" vb = " + Pt.p4 * clock);
//         $p.println(" sa = " + Pt.p5);
//         $p.println(" pa = " + Pt.p6);
//         $p.println("------------------------------- " + count + " (err = " + error + ")");
// }

//       s.pos.x = Pt.p1;
//       s.pos.y = Pt.p2;
//       s.t0 = Pt.p3;
//       s.vel = Pt.p4 * clock;
//       s.theta = Pt.p5;
//       s.phi = Pt.p6;
//     } // for count....

//     var valid = true;
//     if (count >= max_iters) valid = false;
//     if (s.pos.x != s.pos.x || s.pos.y != s.pos.y || s.t0 != s.t0 || s.vel != s.vel || s.theta != s.theta || s.phi != s.phi) valid = false;

// //console.log("DMC marcsearch_compute done, valid=",valid," count=",count," t=",t,"mics=",perm);
//     return valid;
// }



//DMC  function compute(s, timings, n_params, perm, mic_pos) {
function compute_hbar_search_nparms_oneperm(s, mic_pos, mic_timings, res, n_params, parm_mapping, perm/*mics_to_use*/) { // uses res.soundspeed
//  od = compute_hbar_search_nparms_oneperm(s, mic_pos, mic_timings, res, n_params, parm_mapping, mics_to_use);  
//s, mic_pos, mic_timings, res, n_params, mics_to_use
// uses incoming s.theta and s.phi
//console.log("DMC compute_hbar_search_nparms_oneperm incoming th,ph=",s.theta,s.phi,"t0=",s.t0);


	/* New functionality 10-Jan-2018... arbitrary parameter remapping
		> m1=mic_mapping.logical_to_phys('453216',[1,2,3,4,5,6])
		[ 4, 5, 3, 2, 1, 6 ]
	*/

    var mx=[], my=[], mz=[], t=[]; // DMC
    var Pt0 =  new Params();    var Pt =  new Params();    var Pt1 =  new Params();  // DMC
    var Dt =  new Derivatives(); // DMC
    var remapped_Pt = new Params(), remapped_Pt1 =  new Params(), remapped_Dt =  new Derivatives();
    var soln_status = true; // will set to false, if anything invalidates the solution

/*
	// HERE
	var incoming_parms = [ // parameters in canonical order - x y t v theta phi
		s.pos.x,
		s.pos.y,
		s.t0,
		s.vel / clock,
		s.theta,
		s.phi
	];
*/
    Pt0.p1 = s.pos.x;
    Pt0.p2 = s.pos.y;
    Pt0.p3 = s.t0;
    Pt0.p4 = s.vel / clock;
    Pt0.p5 = s.theta;
    Pt0.p6 = s.phi;

    Pt.copyFrom(Pt0);

    va = res.soundspeed / clock;
    
    for (var j =  0;  j < n_params;  j++) {
      var i =  perm[j];
      mx[j] = mic_pos[i].x;
      my[j] = mic_pos[i].y;
      mz[j] = mic_pos[i].z;
      t[j] = mic_timings[i];
      if (t[j] == -1) {
        soln_status = false; // if we are missing a mic timing, this solution is invalid
      }
      if ((traceflag&1)!=0 && shot_n == 1) console.log("mic " + (j+1) + ", t = " + t[j]+" posn=",mic_pos[i]);
    }

    if (!res.n_perms_validmics) res.n_perms_validmics = {};
    if (!res.n_perms_validmics[n_params]) res.n_perms_validmics[n_params] = 0;
    if (soln_status) res.n_perms_validmics[n_params]++;


//console.log("DMC compute_hbar_search_nparms_oneperm t=",t,"mics=",perm);

    if ((traceflag&2)!=0 && shot_n == 1) {
$p.println("compute_hbar_search_nparms_oneperm initial guess:");
//console.log("DMC: s=",s);
//process.exit(1);
      $p.println(" x0 = " + Pt.p1);
      $p.println(" y0 = " + Pt.p2);
      $p.println(" t0 = " + Pt.p3);
      $p.println(" vb = " + Pt.p4 * clock);
      $p.println(" sa = " + Pt.p5);
      $p.println(" pa = " + Pt.p6);
      $p.println("-------------------------------");
    }

    var error =  500; // in original code, this is in cms.
    // Bleck!!!  "error" is not actually an error... it is the amount that a solution moves from one iteration to the next

    // var max_iters =  50;
    var max_iters =  6; // TODO: see if we actually need more than this
    var count = 0;
    for (count = 0;  soln_status && count < max_iters && error > 1 /* mm */; count++) {
  	  // there are only "n_params" mics defined in mx[] etc
      for (var i =  0;  i < n_params;  i++) {
        Dt.o[i] = $p.pow($p.cos(Pt.p5)*(Pt.p1 - mx[i]) + mz[i]*$p.sin(Pt.p5),2) + $p.pow($p.cos(Pt.p6)*(-Pt.p2 + my[i]) + $p.sin(Pt.p6)*($p.cos(Pt.p5)*mz[i] + (-Pt.p1 + mx[i])*$p.sin(Pt.p5)),2) - $p.pow((Pt.p2 - my[i])*$p.sin(Pt.p6) + $p.cos(Pt.p6)*($p.cos(Pt.p5)*mz[i] + (-Pt.p1 + mx[i])*$p.sin(Pt.p5)) + Pt.p4*(Pt.p3 + t[i]),2)/(-1 + $p.pow(Pt.p4,2)/$p.pow(va,2));
        Dt.p1[i] = 2*$p.cos(Pt.p5)*($p.cos(Pt.p5)*(Pt.p1 - mx[i]) + mz[i]*$p.sin(Pt.p5)) - 2*$p.sin(Pt.p6)*$p.sin(Pt.p5)*($p.cos(Pt.p6)*(-Pt.p2 + my[i]) + $p.sin(Pt.p6)*($p.cos(Pt.p5)*mz[i] + (-Pt.p1 + mx[i])*$p.sin(Pt.p5))) + (2*$p.cos(Pt.p6)*$p.sin(Pt.p5)*((Pt.p2 - my[i])*$p.sin(Pt.p6) + $p.cos(Pt.p6)*($p.cos(Pt.p5)*mz[i] + (-Pt.p1 + mx[i])*$p.sin(Pt.p5)) + Pt.p4*(Pt.p3 + t[i])))/(-1 + $p.pow(Pt.p4,2)/$p.pow(va,2));
        Dt.p2[i] = (2*(($p.pow(va,2) - $p.pow(Pt.p4,2))*$p.pow($p.cos(Pt.p6),2)*(Pt.p2 - my[i]) + $p.pow(Pt.p4,2)*$p.cos(Pt.p6)*$p.sin(Pt.p6)*($p.cos(Pt.p5)*mz[i] + (-Pt.p1 + mx[i])*$p.sin(Pt.p5)) + $p.pow(va,2)*$p.sin(Pt.p6)*((Pt.p2 - my[i])*$p.sin(Pt.p6) + Pt.p4*(Pt.p3 + t[i]))))/($p.pow(va,2) - $p.pow(Pt.p4,2));
        Dt.p3[i] = (-2*Pt.p4*((Pt.p2 - my[i])*$p.sin(Pt.p6) + $p.cos(Pt.p6)*($p.cos(Pt.p5)*mz[i] + (-Pt.p1 + mx[i])*$p.sin(Pt.p5)) + Pt.p4*(Pt.p3 + t[i])))/(-1 + $p.pow(Pt.p4,2)/$p.pow(va,2));
        Dt.p4[i] = (2*$p.pow(va,2)*(Pt.p4*(Pt.p2 - my[i])*$p.sin(Pt.p6) + Pt.p4*$p.cos(Pt.p6)*($p.cos(Pt.p5)*mz[i] + (-Pt.p1 + mx[i])*$p.sin(Pt.p5)) + $p.pow(va,2)*(Pt.p3 + t[i]))*((Pt.p2 - my[i])*$p.sin(Pt.p6) + $p.cos(Pt.p6)*($p.cos(Pt.p5)*mz[i] + (-Pt.p1 + mx[i])*$p.sin(Pt.p5)) + Pt.p4*(Pt.p3 + t[i])))/$p.pow($p.pow(va,2) - $p.pow(Pt.p4,2),2);
        Dt.p5[i] = (2*Pt.p4*$p.cos(Pt.p6)*($p.cos(Pt.p5)*(Pt.p1 - mx[i]) + mz[i]*$p.sin(Pt.p5))*(Pt.p4*(Pt.p2 - my[i])*$p.sin(Pt.p6) + Pt.p4*$p.cos(Pt.p6)*($p.cos(Pt.p5)*mz[i] + (-Pt.p1 + mx[i])*$p.sin(Pt.p5)) + $p.pow(va,2)*(Pt.p3 + t[i])))/(-$p.pow(va,2) + $p.pow(Pt.p4,2));
        Dt.p6[i] = (-2*Pt.p4*($p.cos(Pt.p6)*(Pt.p2 - my[i]) - $p.sin(Pt.p6)*($p.cos(Pt.p5)*mz[i] + (-Pt.p1 + mx[i])*$p.sin(Pt.p5)))*(Pt.p4*(Pt.p2 - my[i])*$p.sin(Pt.p6) + Pt.p4*$p.cos(Pt.p6)*($p.cos(Pt.p5)*mz[i] + (-Pt.p1 + mx[i])*$p.sin(Pt.p5)) + $p.pow(va,2)*(Pt.p3 + t[i])))/(-$p.pow(va,2) + $p.pow(Pt.p4,2));
      }
      // remap rows *only* of Dt.px[] and Pt.px
      var Pt_p_mapped_rows = mic_mapping.logical_to_phys(parm_mapping,[Pt.p1,Pt.p2,Pt.p3,Pt.p4,Pt.p5,Pt.p6]);
      remapped_Pt.p1 = Pt_p_mapped_rows[1-1];
      remapped_Pt.p2 = Pt_p_mapped_rows[2-1];
      remapped_Pt.p3 = Pt_p_mapped_rows[3-1];
      remapped_Pt.p4 = Pt_p_mapped_rows[4-1];
      remapped_Pt.p5 = Pt_p_mapped_rows[5-1];
      remapped_Pt.p6 = Pt_p_mapped_rows[6-1];
      var Dt_p_mapped_rows = mic_mapping.logical_to_phys(parm_mapping,[Dt.p1,Dt.p2,Dt.p3,Dt.p4,Dt.p5,Dt.p6]);
      remapped_Dt.p1 = Dt_p_mapped_rows[1-1];
      remapped_Dt.p2 = Dt_p_mapped_rows[2-1];
      remapped_Dt.p3 = Dt_p_mapped_rows[3-1];
      remapped_Dt.p4 = Dt_p_mapped_rows[4-1];
      remapped_Dt.p5 = Dt_p_mapped_rows[5-1];
      remapped_Dt.p6 = Dt_p_mapped_rows[6-1];
      remapped_Dt.o = Dt.o;

      if (n_params == 3) {
        Pt1.p1 = nr_calcs.compute_p11o3(Pt, Dt);
        Pt1.p2 = nr_calcs.compute_p21o3(Pt, Dt);
        Pt1.p3 = nr_calcs.compute_p31o3(Pt, Dt);
        Pt1.p4 = Pt.p4;
        Pt1.p5 = Pt.p5;
        Pt1.p6 = Pt.p6;
      } else if (n_params == 5) {
        remapped_Pt1.p1 = nr_calcs.compute_p11o5(remapped_Pt, remapped_Dt);
        remapped_Pt1.p2 = nr_calcs.compute_p21o5(remapped_Pt, remapped_Dt);
        remapped_Pt1.p3 = nr_calcs.compute_p31o5(remapped_Pt, remapped_Dt);
        remapped_Pt1.p4 = nr_calcs.compute_p41o5(remapped_Pt, remapped_Dt);
        remapped_Pt1.p5 = nr_calcs.compute_p51o5(remapped_Pt, remapped_Dt);
        remapped_Pt1.p6 = remapped_Pt.p6;
        // un-map
        var Pt1_p_unmapped_rows = mic_mapping.phys_to_logical(parm_mapping,[remapped_Pt1.p1,remapped_Pt1.p2,remapped_Pt1.p3,remapped_Pt1.p4,remapped_Pt1.p5,remapped_Pt1.p6])
        Pt1.p1 = Pt1_p_unmapped_rows[1-1];
        Pt1.p2 = Pt1_p_unmapped_rows[2-1];
        Pt1.p3 = Pt1_p_unmapped_rows[3-1];
        Pt1.p4 = Pt1_p_unmapped_rows[4-1];
        Pt1.p5 = Pt1_p_unmapped_rows[5-1];
        Pt1.p6 = Pt1_p_unmapped_rows[6-1];

	  } else if (n_params == 6) { //remap not yet implemented here
		Pt1.p1 = nr_calcs.compute_p11o6(Pt, Dt);
		Pt1.p2 = nr_calcs.compute_p21o6(Pt, Dt);
		Pt1.p3 = nr_calcs.compute_p31o6(Pt, Dt);
		Pt1.p4 = nr_calcs.compute_p41o6(Pt, Dt);
		Pt1.p5 = nr_calcs.compute_p51o6(Pt, Dt);
		Pt1.p6 = nr_calcs.compute_p61o6(Pt, Dt);
	  }

      error = $p.sqrt((Pt.p1 - Pt1.p1) * (Pt.p1 - Pt1.p1) + (Pt.p2 - Pt1.p2) * (Pt.p2 - Pt1.p2));
      Pt.copyFrom(Pt1);
      if ((traceflag&4)!=0 && shot_n == 1) {
        $p.println(" x0 = " + Pt.p1);
        $p.println(" y0 = " + Pt.p2);
        $p.println(" t0 = " + Pt.p3);
        $p.println(" vb = " + Pt.p4 * clock);
        $p.println(" sa = " + Pt.p5);
        $p.println(" pa = " + Pt.p6);
        $p.println("------------------------------- " + count + " (err = " + error + ")");
}
	  // DMC-HERE3 done looping; now reverse-map parms
	  // s.* = unmap(Pt.p1.....)
	  var rev_mapped_outgoing_parms = mic_mapping.phys_to_logical(parm_mapping,[Pt.p1,Pt.p2,Pt.p3,Pt.p4,Pt.p5,Pt.p6])





      s.pos.x = Pt.p1;
      s.pos.y = Pt.p2;
      // Heuristic: we force the Y-coord to be above the plane of the H-bar rather that its
      // symmetrical mirror-image solution below the H-bar
      if (isFinite(s.pos.y) && !isNaN(s.pos.y)) {
        var Y0 = -my[0]; // for hbar, all my[] should be the same
        var isbelow = s.pos.y < -Y0;
        if (isbelow) {
          var abovey = -(s.pos.y + 2*Y0); // mirror-image flip y-coord
          //console.log("DMC isbelow!! s.pos.y=",s.pos.y,Y0,"=abovey",abovey);
          s.pos.y = Pt.p2 = abovey;
        }
      }
      s.t0 = Pt.p3;
      // Heuristic: we want to solve for speed, but keep it sane
      if (Pt.p4< 1*va || Pt.p4 > 5*va) { // limit speed to M=1..5
        //console.log("DMC Heuristic M=1..5: Pt.p4=",Pt.p4,"M=",Pt.p4/va,"v=",Pt.p4*clock);
        Pt.p4 = Pt0.p4; // should we reset to our initial guess?
        Pt.p4 = 2.5*va; // any better if we just reset to M=2.5? (doesn't seem to really matter..)
      }
      s.vel = Pt.p4 * clock;
      s.theta = Pt.p5;
      s.phi = Pt.p6;
    } // for count....

/*
    if (!res.itercnt) res.itercnt = {};
    if (!res.itercnt[n_params]) res.itercnt[n_params] = [];
    res.itercnt[n_params].push({count:count,error:error});
*/

//    if (count >= max_iters) soln_status = false;
    if (error > 10) soln_status = false;
    if (s.pos.x != s.pos.x || s.pos.y != s.pos.y || s.t0 != s.t0 || s.vel != s.vel || s.theta != s.theta || s.phi != s.phi) soln_status = false;


    if ((traceflag&8)!=0 && shot_n == 1) {
    }


if ((traceflag&8)!=0 || ((traceflag&16)!= 0 && soln_status)) console.log("_search_nparms_oneperm done"
," count=",count,"soln_status=",soln_status
//," t=",t,"mics=",perm
," error=",trim_num(error,2)
,"x,y=",trim_num(s.pos.x,0),trim_num(s.pos.y,0)
,"th(mils)",trim_num(s.theta*1000,0),"v=",trim_num(s.vel,0)
);

    return soln_status;
}



// file shot.pde


var generalSearchMethods = (function() {
function generalSearchMethods() { throw 'Unable to create the interface'; }
generalSearchMethods.$isInterface = true;
generalSearchMethods.$methods = ['applyStep'];
return generalSearchMethods;
})();
$p.generalSearchMethods = generalSearchMethods;

var Shot = (function() {
function Shot() {
var $this_1 = this;
function $superCstr(){$p.extendClassChain($this_1)}
$this_1.index =  0;
$this_1.pos =  new XYZ();
$this_1.vel =  0;
$this_1.theta =  0;
$this_1.phi =  0;
$this_1.t0 =  0;
$this_1.angle =  0;
$this_1.dist =  0;
$this_1.mic =  $p.createJavaArray('double', [mic_n]);
$this_1.error =  0;
$this_1.valid =  true;
$this_1.avg_count =  0;
function toString$0_NaN() {
return "shot: "+$this_1.pos.x.toFixed(3) + ", " + $this_1.pos.y.toFixed(3) + ", " + $this_1.pos.z.toFixed(3)
    +", th="+$this_1.theta.toFixed(5)+" ph="+$this_1.phi.toFixed(5)
//    +"\n           "
    +" v="+$this_1.vel.toFixed(1)
    +" t0="+$this_1.t0.toFixed(1)
    +" dist="+$this_1.dist.toFixed(1)
    ;
}

$p.addMethod($this_1, 'toString', toString$0_NaN, false);
function copyFrom$1(s) {
    $this_1.pos.x = s.pos.x;
    $this_1.pos.y = s.pos.y;
    $this_1.pos.z = s.pos.z;
    $this_1.vel = s.vel;
    $this_1.theta = s.theta;
    $this_1.phi = s.phi;
    $this_1.t0 = s.t0;

    $this_1.angle = s.angle;
    $this_1.dist = s.dist;
    $this_1.error = s.error;
//    System.arraycopy(s.mic, 0, $this_1.mic, 0, mic_n);
    $this_1.mic = s.mic.slice(); // DMC

    $this_1.valid = s.valid;
    $this_1.avg_count = s.avg_count; // DMC
}
$p.addMethod($this_1, 'copyFrom', copyFrom$1, false);


function averageAdd$1(s) {
    if (s == null || !s.valid) return;
    $this_1.pos.x += s.pos.x;
    $this_1.pos.y += s.pos.y;
    $this_1.vel += s.vel;
    $this_1.theta += s.theta;
    $this_1.phi += s.phi;
    $this_1.t0 += s.t0;
    $this_1.avg_count++;
}
$p.addMethod($this_1, 'averageAdd', averageAdd$1, false);

function averageDivide$0() {
	if ($this_1.avg_count == 0) {
		$this_1.valid = false;
		return;
	}
    $this_1.valid = true;
    $this_1.pos.x /= $this_1.avg_count;
    $this_1.pos.y /= $this_1.avg_count;
    $this_1.vel /= $this_1.avg_count;
    $this_1.theta /= $this_1.avg_count;
    $this_1.phi /= $this_1.avg_count;
    $this_1.t0 /= $this_1.avg_count;
}
$p.addMethod($this_1, 'averageDivide', averageDivide$0, false);

function simulate$0() {
$this_1.pos.x = $p.random(-250, 250);
      $this_1.pos.y = $p.random(-150, 150);

         $this_1.theta = $p.random(-0.02, 0.02);
    $this_1.phi = $p.random(-0.02, 0.02);      
         $this_1.vel = $p.random(500, 550);

         $this_1.t0 = $this_1.$self.calc_timings();

         for (var i =  0;  i < $this_1.mic.length;  i++) {
$this_1.mic[i] += randomGaussian() * 4;
      $this_1.mic[i] = $p.round($this_1.mic[i]);
}
}
$p.addMethod($this_1, 'simulate', simulate$0, false);

function calc_timings$0() { // uses global 'temperature' and 'mic_pos' and 'mic_n'
console.log("calc_timings is buggy; wron soundspeed; wrong sign for phil die die die"); process.exit(1);

var a =  (331.3 + 0.6 * temperature) / clock;      var vc =  $this_1.vel / clock;      var k =  $p.sqrt((vc*vc * a*a) / (vc*vc - a*a));

         var v_path =  new XYZ();
    v_path.x = $p.sin($this_1.theta) * $p.cos($this_1.phi);
    v_path.y = $p.sin($this_1.phi);
    v_path.z = $p.cos($this_1.theta) * $p.cos($this_1.phi);

    var min_mic =  10000000;

    for (var i =  0;  i < mic_n;  i++) {
var v_mic =  new XYZ(mic_pos[i].x - $this_1.pos.x, mic_pos[i].y - $this_1.pos.y, mic_pos[i].z);

             var shock_start =  v_mic.x * v_path.x + v_mic.y * v_path.y + v_mic.z * v_path.z;
      var shock_start_pos =  new XYZ($this_1.pos.x + v_path.x * shock_start, $this_1.pos.y + v_path.y * shock_start, v_path.z * shock_start);
      var shock_len =  shock_start_pos.dist(mic_pos[i]);

      $this_1.mic[i] = shock_len / k - shock_start / vc;

      if ($this_1.mic[i] < min_mic) min_mic = $this_1.mic[i];
}

         for (var i =  0;  i < mic_n;  i++) {
$this_1.mic[i] -= min_mic;
}

    return 0;
}
$p.addMethod($this_1, 'calc_timings', calc_timings$0, false);

function calc_timings$1(temperature,mic_pos, soundspeed) { // DMC
    //var a =  (331.3 + 0.6 * temperature) / clock; // WRONG!!!
    var a = soundspeed / clock;
    var vc =  $this_1.vel / clock;
    var k =  $p.sqrt((vc*vc * a*a) / (vc*vc - a*a));
    var v_path =  new XYZ();
    v_path.x = $p.sin($this_1.theta) * $p.cos($this_1.phi);
    v_path.y = $p.sin($this_1.phi); // DMC I am 99% sure this is wrong
    v_path.y = $p.sin(-$this_1.phi); // DMC this sign change fixes 6-mic calc'n
    v_path.z = $p.cos($this_1.theta) * $p.cos($this_1.phi);
    // calc_shot.js:calc_timing():
    // var v_path = {x: sin(theta) * cos(phi), y: sin(phi), z: -cos(theta) * cos(phi)};
    //v_path.z = - $p.cos($this_1.theta) * $p.cos($this_1.phi); // make this same as calc_shot.js:calc_timing()

    var min_mic =  10000000; var mic_n = mic_pos.length;

    for (var i =  0;  i < mic_n;  i++) {
      var v_mic =  new XYZ(mic_pos[i].x - $this_1.pos.x, mic_pos[i].y - $this_1.pos.y, mic_pos[i].z);
      var shock_start =  v_mic.x * v_path.x + v_mic.y * v_path.y + v_mic.z * v_path.z;
      var shock_start_pos =  new XYZ($this_1.pos.x + v_path.x * shock_start, $this_1.pos.y + v_path.y * shock_start, v_path.z * shock_start);
      var shock_len =  shock_start_pos.dist(mic_pos[i]);
      $this_1.mic[i] = shock_len / k - shock_start / vc;

      if ($this_1.mic[i] < min_mic) min_mic = $this_1.mic[i];
    }
    
    for (var i =  0;  i < mic_n;  i++) {
      $this_1.mic[i] =  Math.round($this_1.mic[i] - min_mic);
    }

    return 0;
}
$p.addMethod($this_1, 'calc_timings_1', calc_timings$1, false);


function timing_error$2(mic1, mic2) {
var avg1 =  0;
    var avg2 =  0;
    for (var i =  0;  i < mic_n;  i++) {
avg1 += mic1[i];
      avg2 += mic2[i];
}
    avg1 /= mic_n;
    avg2 /= mic_n;
    var avg =  0;
    for (var i =  0;  i < mic_n;  i++) {
var err =  $p.abs((mic1[i] - avg1) - (mic2[i] - avg2));
      avg += err * err;
}
    avg /= mic_n;
    return $p.sqrt(avg);
}
$p.addMethod($this_1, 'timing_error', timing_error$2, false);

function timing_error2_dmc(mic1, mic2) { // ignore missing timings; returns sum of squares of errors
    var avg1 = 0, avg2 = 0;
    var mic_n = mic1.length, n_valid_mics=0;
    for (var i =  0;  i < mic_n;  i++) {
      if (mic1[i]!=-1 && mic2[i]!=-1) {
        avg1 += mic1[i];
        avg2 += mic2[i];
        n_valid_mics++;
      }
	}
	if (n_valid_mics == 0) return NaN;
    avg1 /= n_valid_mics;
    avg2 /= n_valid_mics;
    var avg =  0;
    for (var i =  0;  i < mic_n;  i++) {
      if (mic1[i]!=-1 && mic2[i]!=-1) {
        var err =  $p.abs((mic1[i] - avg1) - (mic2[i] - avg2));
        avg += err * err;
      }
    }
//console.log("DMC timing_error2_dmc ",mic_n,"avg1,2",avg1,avg2);
//a.b.c=45; // crash!!
    return $p.sqrt(avg); 
}

// try a different way... without offsetting from the mean... doesn't seem to be much (or usefully) different


// another thing to try: "vector length of mic timings used in perm"
function timing_error3_dmc(mic1/*simulated*/, mic2/*actual*/,perm) { // ignore missing timings; returns sum of squares of errors
    var mic_n = mic1.length, n_valid_mics=0;
    var avg = 0;
//    for (var i =  0;  i < mic_n;  i++) {
    for (var j =  0;  j < perm.length;  j++) {
		i = perm[j];
		if (mic1[i]!=-1 && mic2[i]!=-1) {
			n_valid_mics++;
			var err =  mic1[i] - mic2[i];
			avg += mic2[i];
		}
    }
	if (n_valid_mics == 0) return NaN;
	avg /= n_valid_mics;
	var err2 = 0;
    for (var j =  0;  j < perm.length;  j++) {
		i = perm[j];
		if (mic1[i]!=-1 && mic2[i]!=-1) {
			var err = mic2[i]-avg;
			err2 += err*err;
		}
    }

    return $p.sqrt(err2); //  "vector length of mic timings used in this perm'n" 
}



// // DMCfunction compute$2(thread, mic_actual) {
// function compute$2(/*thread*/mic_pos, mic_actual) {// DMC

// ///* DMC
// var v1 =  clock * (mic_pos[4].z - mic_pos[0].z) / (mic_actual[0] - mic_actual[4]);
//     var v2 =  clock * (mic_pos[5].z - mic_pos[1].z) / (mic_actual[1] - mic_actual[5]);
//     var v3 =  clock * (mic_pos[6].z - mic_pos[2].z) / (mic_actual[2] - mic_actual[6]);
//     var v4 =  clock * (mic_pos[7].z - mic_pos[3].z) / (mic_actual[3] - mic_actual[7]);
//     $this_1.vel = (v1 + v2 + v3 + v4) / 4;

//    $this_1.pos.x = 0;
//    $this_1.pos.y = 0;
//    $this_1.valid = false;
//     $this_1.t0 = 1000000;
// console.log("DMC shot.compute initial guesses ",$this_1.toString());
// //DMC */


// //$this_1.$self = this; // try??
// //console.log("DMC:$this_1",$this_1);
// //console.log("DMC:this",this);


//          $this_1./*$self.*/compute_marcsearch(/*thread*/mic_pos, mic_actual, 3);
//    if(!$this_1.valid) return;

// //console.log("DMC- shot.compute terminating after only trying 3-mic combos",$this_1)
// //return;
// console.log("DMC- shot.compute             after             3-mic combos",$this_1)

//          $this_1/*.$self*/.improve_by_quadrant();

// //console.log("DMC- shot.compute terminating after improve_by_quadrant()",$this_1)
// //return;
// console.log("DMC- shot.compute after improve_by_quadrant()",$this_1)


//    // this HARDCODING needs to be fixed.... maybe, 0.75x the mic_w,mic_h parameters?
//    if ($p.abs($this_1.pos.x) < 120*effingcm_to_mm && $p.abs($this_1.pos.y) < 120*effingcm_to_mm) { // cm
//       $this_1/*.$self*/.compute_marcsearch(/*thread*/mic_pos, mic_actual, 6);
// console.log("DMC- shot.compute             after             6-mic combos",$this_1)
//    }
// }
// $p.addMethod($this_1, 'compute', compute$2, false);







function compute_hbar(mic_pos, mic_actual_timings, res, geom) {// DMC

/*    var v1 =  clock * (mic_pos[4].z - mic_pos[0].z) / (mic_actual_timings[0] - mic_actual_timings[4]);
    var v2 =  clock * (mic_pos[5].z - mic_pos[1].z) / (mic_actual_timings[1] - mic_actual_timings[5]);
    var v3 =  clock * (mic_pos[6].z - mic_pos[2].z) / (mic_actual_timings[2] - mic_actual_timings[6]);
    var v4 =  clock * (mic_pos[7].z - mic_pos[3].z) / (mic_actual_timings[3] - mic_actual_timings[7]);
    $this_1.vel = (v1 + v2 + v3 + v4) / 4;
*/
   var nmics = 0, vtot = 0;
   function calc_v(m1,m2) {
     var t1 = mic_actual_timings[m1-1]; var t2 = mic_actual_timings[m2-1];
     if (t1 == -1 || t2 == -1 || t1==t2) return 0;
	 // DMC 7-Jan-2018 - don't calc speeds for "chrono pairs" with a raised rear sensor
	 if (abs(mic_pos[m1-1].y - mic_pos[m2-1].y)>1) {
		 //console.log("DMC: calc_v rejecting because dy>1",m1,m2);
		 return 0;
	 }
     var v =  clock * (mic_pos[m1-1].z - mic_pos[m2-1].z) / (t2-t1); // DMC it looks like there is a sign error here, but there isn't
     return v;
   }
   var v13 = calc_v(1,3); if (v13) {vtot += v13; nmics++; }
   var v26 = calc_v(2,6); if (v26) {vtot += v26; nmics++; }
   var v47 = calc_v(4,7); if (v47) {vtot += v47; nmics++; }
   var v58 = calc_v(5,8); if (v58) {vtot += v58; nmics++; }
   $this_1.vel = 0;
   if (nmics) {
   	 $this_1.vel = vtot / nmics;
   	 if (1) {
   	   if(v13) res.raw_v13 = v13;
   	   if(v26) res.raw_v26 = v26;
   	   if(v47) res.raw_v47 = v47;
   	   if(v58) res.raw_v58 = v58;
   	   res.raw_v = $this_1.vel;
   	 }
   }

   $this_1.pos.x = 0;
   $this_1.pos.y = 0;
   $this_1.valid = false;
   $this_1.t0 = 10000; // ->        "calcd_t0": 1489.7738986108095,
//$this_1.t0 = 32748; // ->         "calcd_t0": 1638.7512884718676,


//console.log("DMC shot.compute_hbar initial guesses ",$this_1.toString(),v13,v26,v47,v58);



//$this_1.$self = this; // try??
//console.log("DMC:$this_1",$this_1);
//console.log("DMC:this",this);


   if (!res.timing_error2)  res.timing_error2= {};

   $this_1.compute_hbar_search_nparms(mic_pos, mic_actual_timings, res, geom, 3, '123456'/*x,y,t0*/,undefined/*search all perms*/);

   if (traceflag&8) console.log("DMC compute_hbar 3-parms",$this_1.toString());
   res.valid_3mics = $this_1.valid;
   if(!$this_1.valid) return;
   var s_3 =  new Shot;
   s_3.copyFrom($this_1); // save sol'n from 3-parm calc'n, in case other sol'ns don't converge
   
   
   
   s_3.calc_timings_1(res.temp,mic_pos,res.soundspeed);
   var timing_error = res.timing_error2['3'] = trim_num(timing_error2_dmc(s_3.mic,mic_actual_timings),1);
//console.log("DMC compute_hbar 3-parms, valid=",$this_1.valid,$this_1.pos.x,$this_1.pos.y,"timing_error=",timing_error);


/*
console.log("DMC compute_hbar s_3",s_3.valid,s_3.pos.x,s_3.pos.y,"timing_error=",timing_error);
console.log("DMC 3",$this_1.toString());
*/

//console.log("DMC- shot.compute_hbar terminating after only trying 3-mic combos",$this_1)
//return;
//console.log("DMC- shot.compute_hbar             after             3-mic combos",$this_1)
   if ('HBAR3' == geom.sens_geom) return;
   if ('HBAR4' == geom.sens_geom) return;
   

   var save_traceflag = traceflag; // push traceflag
   traceflag |= 1/*mic#s */
   traceflag |= 2/*initial conds */
   traceflag |= 4/**results--per-loop */
   traceflag |= 8/**results-at-loop-end regardless of soln_status */
   traceflag |= 16/**results-at-loop-end only for successful soln_status  */
   

   $this_1.valid = false;
   $this_1.compute_hbar_search_nparms(mic_pos, mic_actual_timings, res, geom
// TODO: revisit this:
//	, 5, '124356'/*x,y,t0,v,sa*/,[6,22]/*search only perms usable by both HBAR and HVBAR*/);
	, 5, '124356'/*x,y,t0,v,sa*/,undefined/*search all perms*/);
   $this_1.calc_timings_1(res.temp,mic_pos,res.soundspeed);
   if(traceflag&1) console.log("DMC 5 mic timings(all-perms) for",$this_1.toString());
   var timing_error = res.timing_error2['5'] = trim_num(timing_error2_dmc($this_1.mic,mic_actual_timings),1);
   if (traceflag&16 || traceflag&8) {
    console.log("DMC 5 mic_calc vs actual",$this_1.mic,mic_actual_timings)
    console.log("DMC compute_hbar 5-parms, valid=",$this_1.valid,$this_1.pos.x,$this_1.pos.y,"timing_error=",timing_error);
    console.log("DMC 5",$this_1.toString());
   }
  traceflag = save_traceflag; //pop

  res.valid_5mics = $this_1.valid;
   if(!$this_1.valid) { // at least we have a cruder calc'n available:
     $this_1.copyFrom(s_3); // save sol'n from 3-parm calc'n, in case other sol'ns don't converge
     return; // no sense trying 6-mics if 5-mics didn't work
   }
   var s_5 =  new Shot; s_5.copyFrom($this_1); // save sol'n from 5-parm calc'n

   if ('HBAR5' == geom.sens_geom) return;
   if ('VBAR5' == geom.sens_geom) return;
   if ('HVBAR5' == geom.sens_geom) return;

   $this_1.valid = false;
   if ('HVBAR6' == geom.sens_geom) {
	   $this_1.compute_hbar_search_nparms(mic_pos, mic_actual_timings, res, geom
	   , 6, '123456', [19]); // for HVBAR6 we want 135678, which is perm# 19
   } else { // HBAR6... don't have any good ideas for it, for now
	   $this_1.compute_hbar_search_nparms(mic_pos, mic_actual_timings, res, geom
	   , 6, '123456', undefined/*for now - search all*/);
   }
   res.valid_6mics = $this_1.valid;
   $this_1.calc_timings_1(res.temp,mic_pos,res.soundspeed);
   var timing_error = res.timing_error2['6'] = trim_num(timing_error2_dmc($this_1.mic,mic_actual_timings),1);
//console.log("DMC compute_hbar 6-parms, valid=",$this_1.valid,$this_1.pos.x,$this_1.pos.y,"timing_error=",timing_error);
//console.log("DMC 6 mic_calc vs actual",$this_1.mic,mic_actual_timings)

// PCEngines vs. my desktop
// AMD GX-412TC SOC vs. Intel(R) Core(TM) i5-2500 CPU @ 3.30GHz
//   "e_t_ms": 2624.60697100004(cold)   "e_t_ms": 882.1185660001447 (warm)
//   "e_t_ms": 312.9403553903103(cold) "e_t_ms": 61.81957293301821 "e_t_ms": 59.65
//
// seems to take several shots for speed to settle; perhaps incremental compiling??
//
// AMD GX-412TC SOC ~40ms, desktop ~
//
// ... I can't wait to see how the ar71xx does...!!!
//
// PCEngines APU2 AMD GX-412TC SOC vs. OM-O2P: 6512ms vs 14650ms (ADLtest2)

   if(!$this_1.valid) { // at least we have a cruder calc'n available:
     $this_1.copyFrom(s_5);
   }
//console.log("DMC compute_hbar final,",$this_1.valid,$this_1.pos.x,$this_1.pos.y);
//85624713

}
$p.addMethod($this_1, 'compute_hbar', compute_hbar, false);





function compute_hbar_search_nparms(mic_pos, mic_timings, res, geom
  , n_params, parm_mapping
  , perms_to_use // undefined --> use all available perms, otherwise list of permutations to use e.g. [6,22,11]
  ) {
  var s_avg =  new Shot($this_1.index); // note: ctor sets s_avg.valid = true
  s_avg.valid = false;

  var perm =  null, i, perms_avail, perms_to_try;
  if (n_params == 3) perms_avail = combinations_3_of_8;
  else if (n_params == 4) perms_avail = combinations_4_of_8;
  else if (n_params == 5) perms_avail = combinations_5_of_8;
  else if (n_params == 6) perms_avail = combinations_6_of_8;
  
  if (perms_to_use) {
	  perms_to_try = [];
	  for (i in perms_to_use) perms_to_try.push(perms_avail[perms_to_use[i]])
  } else {
	  perms_to_try = perms_avail;
  }

/*
  var good_5 = [6,17,22,24,27,28]; // klugey.... for now
  var good_5 = [27]; // klugey.... for now
  var good_5 = [6,22]; // ...unbelievably clever....

  var good_6 = [19]; // perm'n #19 is mic #135678, which are the "HVBAR" verticall
  // mics #6 and #7, plus the outermost chronos 1+3 and 5+8
*/

  var best_timing_error = -1;
  var best_xx;
  var best_shot = new Shot();

  if (!perms_to_try) return;

  for (var m in perms_to_try) { // DMC m = 0.. (index into array perm[]
    var s = new Shot($this_1.index);
	  var mics_to_use = perms_to_try[m];
    if(traceflag&2) console.log('DMC compute_hbar_search_nparms", n_params, "$this_1.index=',$this_1.index,"perm#=",m,"mics_to_use=",mics_to_use);
    s.copyFrom($this_1/*.$self*/);

	  // DMC: pass in theta,phi hints
    if (geom.theta_cal && geom.theta_cal != 0) s.theta = geom.theta_cal/1000; // convert from mils
    if (geom.phi_cal && geom.phi_cal != 0) s.phi = geom.phi_cal/1000; // convert from mils
	
    var s_good = compute_hbar_search_nparms_oneperm(s, mic_pos, mic_timings, res, n_params, parm_mapping, mics_to_use);  

    if (!res.n_perms_valid) res.n_perms_valid = {};
    if (!res.n_perms_valid[n_params]) res.n_perms_valid[n_params] = 0;
    if (!res.n_perms_tried) res.n_perms_tried = {};
    if (!res.n_perms_tried[n_params]) res.n_perms_tried[n_params] = 0;
    res.n_perms_tried[n_params]++;
    if (s_good) res.n_perms_valid[n_params]++;
    
/*    
          s2.calc_timings();
      s2.error = timing_error2_dmc(mic_actual, s2.mic);
      if (print) $p.println(" right error = " + s2.error);
*/
    
    
    // TODO: reject shots with too much timing_error
    // (must consider how to handle missing mics or mics with bad readings)
    // maybe we should move this into compute_hbar_search_nparms_oneperm
    // maybe we should consider timing error of initial guess vs. "solution", and reject "solution"
    // if it is worse than the guess.
    
    s.valid = s_good;
  	var yy = {};
    if (s.valid) {
      s_avg.valid = true;
      s_avg.averageAdd(s);
      s.calc_timings_1(res.temp,mic_pos,res.soundspeed);
      var timing_error = trim_num(timing_error2_dmc(s.mic,mic_timings));
      var timing_error3 = trim_num(timing_error3_dmc(s.mic,mic_timings,mics_to_use));
      var xx = [trim_num(s.pos.x,2),trim_num(s.pos.y,2),trim_num(s.vel),trim_num(s.theta*1000),trim_num(s.phi*1000),timing_error];
      yy={  // this is used for analysis/visualization in viewer_toolbar_arc.js
        x:trim_num(s.pos.x,2), y:trim_num(s.pos.y,2) //,v:trim_num(s.vel), // th:trim_num(s.theta*1000)+","+trim_num(s.phi*1000)+
          //timing_error:timing_error, timing_error3:timing_error3
      }
      if (best_timing_error < 0 || timing_error < best_timing_error) {
        if (!res.best_shot) res.best_shot={};
        res.best_shot[n_params] = xx;
      	best_timing_error = timing_error;
      	best_xx = xx;
      	best_shot.copyFrom(s);
      }
    }
    if (!res.all_shot_perms) res.all_shot_perms={};
    if (!res.all_shot_perms[n_params]) res.all_shot_perms[n_params] = [];
    res.all_shot_perms[n_params].push(yy); // == "" for invalid
  } // ...for (var m in perms_to_try)

  s_avg.averageDivide();
  
  if (s_avg.valid) $this_1/*.$self*/.copyFrom(s_avg);

/*  
  // DMC - instead of average, just choose best:
  $this_1.copyFrom(best_shot); // note, this is not nearly as clever as it sounds.
  
  // DMC 9-Jan-2018.. temp'y kluge
//console.log("DMC compute_hbar_search_nparms n_params=",n_params,"s_avg=",s_avg,$this_1,"\n")
  if (5 == n_params) {
	if (s_avg.valid) {
		$this_1.copyFrom(s_avg);
		console.log("DMC use s_avg",s_avg.pos);
	} else {
		console.log("DMC s_avg invalid");
	}
  }
*/

/*
s_avg.calc_timings_1(res.temp,mic_pos,res.soundspeed);
var timing_error = timing_error2_dmc(s_avg.mic,mic_timings);
console.log("DMC compute_hbar_search_nparms("+n_params+"): s_avg===>",s_avg.toString(),"timing_error=",timing_error);
console.log("DMC best_xx ",best_xx," best_shot===>",best_shot.toString());
console.log("\n");
*/

}

$p.addMethod($this_1, 'compute_hbar_search_nparms', compute_hbar_search_nparms, false);








// function compute_marcsearch$3(/*thread*/mic_pos, mic_actual, n_params) {
// var s_avg =  new Shot($this_1.index);

//          var sol =  getPermList($this_1.pos, n_params);

// //console.log("DMCmarcsearch$3 n_params=",n_params,this);
// //console.log("DMCmarcsearch$3 mic_actual=",mic_actual);
// //console.log("DMCmarcsearch$3 permlist=",sol);



// //    for (var $it0 = new $p.ObjectIterator( sol), mi  = void(0); $it0.hasNext() && ((mi  = $it0.next()) || true);) {
// //var m =  mi.intValue();
//     for (var i in sol) { // DMC
//       var m =  sol[i];// DMC

//              var s =  new Shot($this_1.index);
// //console.log('DMC compute_marcsearch$3 $this_1.index',$this_1.index);
//       s.copyFrom($this_1/*.$self*/);
// //console.log('DMC compute_marcsearch$3 copyFrom this=',$this_1,"s=",s);
// //process.exit(1);
//       var perm =  null;
//       if (n_params == 3) perm = perm3;
//       else if (n_params == 4) perm = perm4;
//       else if (n_params == 5) perm = perm5;
//       else if (n_params == 6) perm = perm6;

// //console.log("DMC: call marcsearch_compute, s=",s);
// //console.log("DMC compute_marcsearch: this.v=",this.vel,"s.vel=",s.vel, "n_params=",n_params,"perm#",m);

//       var res =  marcsearch_compute(s, mic_actual, n_params, perm[m], mic_pos);  
// //      boolean res = marc[thread].compute(s, mic_actual, n_params, perm[m]); // execute 3 param search
//       shot_marc[m][$this_1.index] = s;      
// //console.log("DMC   shot_marc[",m,"][",$this_1.index,"]");

//       s.valid = res;
// //      console.log("DMC compute_marcsearch: ===>",s.toString());


//              s_avg.averageAdd(s);
// }

//     s_avg.averageDivide();

//     if (s_avg.valid) $this_1/*.$self*/.copyFrom(s_avg);
// }
// $p.addMethod($this_1, 'compute_marcsearch', compute_marcsearch$3, false);



function improve_by_quadrant$0() {
var select =  null;
    if ($this_1.pos.x <= 0 && $this_1.pos.y <= 0) {
select = [0, 1, 2, 3, 4, 5, 6, 7];
} else if ($this_1.pos.x > 0 && $this_1.pos.y <= 0) {
select = [8, 9, 10, 11, 12, 13, 14, 15];
} else if ($this_1.pos.x <= 0 && $this_1.pos.y > 0) {
select = [16, 17, 18, 19, 20, 21, 22, 23];
} else if ($this_1.pos.x > 0 && $this_1.pos.y > 0) {
select = [24, 25, 26, 27, 28, 29, 30, 31];
}

         var s_avg =  new Shot($this_1.index);
    for (var i =  0;  i < select.length;  i++) {
var m =  select[i];

      var s =  shot_marc[m][$this_1.index];  
      s_avg.averageAdd(s);
}

    s_avg.averageDivide();

    if (s_avg.valid) $this_1/*.$self*/.copyFrom(s_avg);
    $this_1.perms_used_DMC_DEBUG = select; // DMC
}
$p.addMethod($this_1, 'improve_by_quadrant', improve_by_quadrant$0, false);


function generalSearch$5(print, mic_actual, step_init, step_min, func) {
var s1 =  new Shot(-1);
    var s2 =  new Shot(-1);

    var step =  step_init;

    var count =  0;
    while (count++ < 1000 && step >= step_min) {
global_count++;

      if (print) $p.println("searching from " + dec1($this_1.pos.x) + "," + dec1($this_1.pos.y) + ", vel = " + dec1($this_1.vel) + ", error = " + dec1($this_1.error));

      s1.copyFrom($this_1.$self);
      func.applyStep(s1, -step);
      s1.calc_timings();
      s1.error = s1.timing_error(mic_actual, s1.mic);
      if (print) $p.println(" left error = " + s1.error);

      s2.copyFrom($this_1.$self);
      func.applyStep(s2, step);
      s2.calc_timings();
      s2.error = s2.timing_error(mic_actual, s2.mic);
      if (print) $p.println(" right error = " + s2.error);

             if (s1.error >= $this_1.error && s2.error >= $this_1.error) {
if (print) $p.println(" no improvement; decreasing step");
        step /= 2;
} else if (s1.error < s2.error) {
if (print) $p.println(" left is better");
        $this_1.$self.copyFrom(s1);
} else {
if (print) $p.println(" right is better");
        $this_1.$self.copyFrom(s2);
}
}
    if (print) {
$p.println("search complete: " + count + " steps");
      $p.println("ended at " + dec1($this_1.pos.x) + "," + dec1($this_1.pos.y) + ", vel = " + dec1($this_1.vel) + ", error = " + dec1($this_1.error));
}
}
$p.addMethod($this_1, 'generalSearch', generalSearch$5, false);
function searchVXY$1(mic_actual) {
$this_1.pos.x = 10;
    $this_1.pos.y = 0;
    $this_1.angle = 0;
    $this_1.dist = 10;

    $this_1.$self.calc_timings();
    $this_1.error = $this_1.$self.timing_error(mic_actual, $this_1.mic);

         $this_1.$self.generalSearch(false, mic_actual, $p.radians(45), $p.radians(1), new ((function() {
function generalSearchMethods$class3() {
var $this_2 = this;
function $superCstr(){$p.extendClassChain($this_2)}
function applyStep$2(s, step) {
s.angle += step;
        s.pos.x = s.dist * $p.cos(s.angle);
        s.pos.y = s.dist * $p.sin(s.angle);
}
$p.addMethod($this_2, 'applyStep', applyStep$2, false);
function $constr() {
$superCstr();
}
$constr.apply(null, arguments);
}
$p.extendInterfaceMembers(generalSearchMethods$class3, generalSearchMethods);
generalSearchMethods$class3.$interfaces = [generalSearchMethods];
return generalSearchMethods$class3;
})()));

         $this_1.$self.generalSearch(false, mic_actual, 100, 10, new ((function() {
function generalSearchMethods$class4() {
var $this_2 = this;
function $superCstr(){$p.extendClassChain($this_2)}
function applyStep$2(s, step) {
s.dist += step;
        s.pos.x = s.dist * $p.cos(s.angle);
        s.pos.y = s.dist * $p.sin(s.angle);
}
$p.addMethod($this_2, 'applyStep', applyStep$2, false);
function $constr() {
$superCstr();
}
$constr.apply(null, arguments);
}
$p.extendInterfaceMembers(generalSearchMethods$class4, generalSearchMethods);
generalSearchMethods$class4.$interfaces = [generalSearchMethods];
return generalSearchMethods$class4;
})()));
}
$p.addMethod($this_1, 'searchVXY', searchVXY$1, false);
function $constr_1(index){
$superCstr();

$this_1.index = index;
}

function $constr() {
if(arguments.length === 1) { $constr_1.apply($this_1, arguments); } else $superCstr();
}
$constr.apply(null, arguments);
}
return Shot;
})();
$p.Shot = Shot;










// file permutations.pde

// // perm: each possible combination of microphones (assuming 8 mics)

// /*
// int perm3[][] = new int[][] {
  
//   // 0 to 9
//   {0, 1, 2}, {0, 1, 3}, {0, 1, 6}, {0, 1, 7}, {0, 2, 3}, {0, 2, 5}, {0, 2, 7}, {0, 3, 5}, {0, 3, 6}, {0, 5, 6},
  
//   // 10 to 19
//   {0, 5, 7}, {0, 6, 7}, {1, 2, 3}, {1, 2, 4}, {1, 2, 7}, {1, 3, 4}, {1, 3, 6}, {1, 4, 6},{1, 4, 7}, {1, 6, 7},
  
//   // 20 to 29
//   {2, 3, 4}, {2, 3, 5}, {2, 4, 5}, {2, 4, 7}, {2, 5, 7}, {3, 4, 5}, {3, 4, 6}, {3, 5, 6}, {4, 5, 6}, {4, 5, 7},
  
//   // 30 31
//   {4, 6, 7}, {5, 6, 7}
  
// };
// */



// var perm3 =  [
//   [1, 2, 3], [1, 2, 7], [1, 3, 6], [1, 6, 7], [2, 3, 5], [2, 5, 7], [3, 5, 6], [5, 6, 7],
//   [0, 2, 3], [0, 2, 7], [0, 3, 6], [0, 6, 7], [2, 3, 4], [2, 4, 7], [3, 4, 6], [4, 6, 7],
//   [0, 1, 3], [0, 1, 7], [0, 3, 5], [0, 5, 7], [1, 3, 4], [1, 4, 7], [3, 4, 5], [4, 5, 7],
//   [0, 1, 2], [0, 1, 6], [0, 2, 5], [0, 5, 6], [1, 2, 4], [1, 4, 6], [2, 4, 5], [4, 5, 6]
// ];


// // DMC 24-May: those "perm3" are not all of the combinations!!!
// //
// // ExportString[Subsets[Range[0, 7], {3}], "JSON", "Compact" -> True]

var combinations_3_of_8 = [[0,1,2],[0,1,3],[0,1,4],[0,1,5],[0,1,6],[0,1,7],[0,2,3],[0,2,4],[0,
2,5],[0,2,6],[0,2,7],[0,3,4],[0,3,5],[0,3,6],[0,3,7],[0,4,5],[0,4,6],[
0,4,7],[0,5,6],[0,5,7],[0,6,7],[1,2,3],[1,2,4],[1,2,5],[1,2,6],[1,2,7]
,[1,3,4],[1,3,5],[1,3,6],[1,3,7],[1,4,5],[1,4,6],[1,4,7],[1,5,6],[1,5,
7],[1,6,7],[2,3,4],[2,3,5],[2,3,6],[2,3,7],[2,4,5],[2,4,6],[2,4,7],[2,
5,6],[2,5,7],[2,6,7],[3,4,5],[3,4,6],[3,4,7],[3,5,6],[3,5,7],[3,6,7],[
4,5,6],[4,5,7],[4,6,7],[5,6,7]];

var combinations_4_of_8 = [[0,1,2,3],[0,1,2,4],[0,1,2,5],[0,1,2,6],[0,1,2,7],[0,1,3,4],[0,1,3,
5],[0,1,3,6],[0,1,3,7],[0,1,4,5],[0,1,4,6],[0,1,4,7],[0,1,5,6],[0,1,5,
7],[0,1,6,7],[0,2,3,4],[0,2,3,5],[0,2,3,6],[0,2,3,7],[0,2,4,5],[0,2,4,
6],[0,2,4,7],[0,2,5,6],[0,2,5,7],[0,2,6,7],[0,3,4,5],[0,3,4,6],[0,3,4,
7],[0,3,5,6],[0,3,5,7],[0,3,6,7],[0,4,5,6],[0,4,5,7],[0,4,6,7],[0,5,6,
7],[1,2,3,4],[1,2,3,5],[1,2,3,6],[1,2,3,7],[1,2,4,5],[1,2,4,6],[1,2,4,
7],[1,2,5,6],[1,2,5,7],[1,2,6,7],[1,3,4,5],[1,3,4,6],[1,3,4,7],[1,3,5,
6],[1,3,5,7],[1,3,6,7],[1,4,5,6],[1,4,5,7],[1,4,6,7],[1,5,6,7],[2,3,4,
5],[2,3,4,6],[2,3,4,7],[2,3,5,6],[2,3,5,7],[2,3,6,7],[2,4,5,6],[2,4,5,
7],[2,4,6,7],[2,5,6,7],[3,4,5,6],[3,4,5,7],[3,4,6,7],[3,5,6,7],[4,5,6,
7]];

var combinations_5_of_8 = [
  [0,1,2,3,4], // 0
  [0,1,2,3,5],
  [0,1,2,3,6],
  [0,1,2,3,7],
  [0,1,2,4,5],
  [0,1,2,4,6],// 5
  [0,1,2,4,7],// 6
  [0,1,2,5,6],
  [0,1,2,5,7],
  [0,1,2,6,7],
  [0,1,3,4,5],//10
  [0,1,3,4,6],
  [0,1,3,4,7],
  [0,1,3,5,6],
  [0,1,3,5,7],
  [0,1,3,6,7],[0,1,4,5,6],[0,1,4,5,7],[0,1,4,6,7],[0,1,5,6,7],[0,2,3,4,5],[0,2,3,4,6],
  [0,2,3,4,7]/*22 */,
  [0,2,3,5,6],[0,2,3,5,7],[0,2,3,6,7],[0,2,4,5,6],[0,2,4,5,7],[0,2,4,6,7]
,[0,2,5,6,7],[0,3,4,5,6],[0,3,4,5,7],[0,3,4,6,7],[0,3,5,6,7],[0,4,5,6,
7],[1,2,3,4,5],[1,2,3,4,6],[1,2,3,4,7],[1,2,3,5,6],[1,2,3,5,7],[1,2,3,
6,7],[1,2,4,5,6],[1,2,4,5,7],[1,2,4,6,7],[1,2,5,6,7],[1,3,4,5,6],[1,3,
4,5,7],[1,3,4,6,7],[1,3,5,6,7],[1,4,5,6,7],[2,3,4,5,6],[2,3,4,5,7],[2,
3,4,6,7],[2,3,5,6,7],[2,4,5,6,7],[3,4,5,6,7]];

var combinations_6_of_8 = [[0,1,2,3,4,5],[0,1,2,3,4,6],[0,1,2,3,4,7],[0,1,2,3,5,6],[0,1,2,3,5,
7],[0,1,2,3,6,7],[0,1,2,4,5,6],[0,1,2,4,5,7],[0,1,2,4,6,7],[0,1,2,5,6,
7],[0,1,3,4,5,6],[0,1,3,4,5,7],[0,1,3,4,6,7],[0,1,3,5,6,7],[0,1,4,5,6,
7],[0,2,3,4,5,6],[0,2,3,4,5,7],[0,2,3,4,6,7],[0,2,3,5,6,7],[0,2,4,5,6,
7],[0,3,4,5,6,7],[1,2,3,4,5,6],[1,2,3,4,5,7],[1,2,3,4,6,7],[1,2,3,5,6,
7],[1,2,4,5,6,7],[1,3,4,5,6,7],[2,3,4,5,6,7]];


// /*
//     if (pos.x < 0 && pos.y < 0) {
//       select = new int[] {12, 14, 16, 19, 21, 24, 27, 31};
//     } else if (pos.x > 0 && pos.y < 0) {
//       select = new int[] {4, 6, 8, 11, 20, 23, 26, 30};
//     } else if (pos.x < 0 && pos.y > 0) {
//       select = new int[] {1, 3, 7, 10, 15, 18, 25, 29};
//     } else if (pos.x > 0 && pos.y > 0) {
//       select = new int[] {0, 2, 5, 9, 13, 17, 22, 28};
// */



// var perm4 =  [
//    [0, 1, 2, 3], [0, 1, 2, 4], [0, 1, 2, 5], [0, 1, 2, 6], [0, 1, 2, 
//   7], [0, 1, 3, 4], [0, 1, 3, 5], [0, 1, 3, 6], [0, 1, 3, 7], [0, 1, 
//   4, 5], [0, 1, 4, 6], [0, 1, 4, 7], [0, 1, 5, 6], [0, 1, 5, 7], [0, 
//   1, 6, 7], [0, 2, 3, 4], [0, 2, 3, 5], [0, 2, 3, 6], [0, 2, 3, 
//   7], [0, 2, 4, 5], [0, 2, 4, 6], [0, 2, 4, 7], [0, 2, 5, 6], [0, 2, 
//   5, 7], [0, 2, 6, 7], [0, 3, 4, 5], [0, 3, 4, 6], [0, 3, 4, 7], [0, 
//   3, 5, 6], [0, 3, 5, 7], [0, 3, 6, 7], [0, 4, 5, 6], [0, 4, 5, 
//   7], [0, 4, 6, 7], [0, 5, 6, 7], [1, 2, 3, 4], [1, 2, 3, 5], [1, 2, 
//   3, 6], [1, 2, 3, 7], [1, 2, 4, 5], [1, 2, 4, 6], [1, 2, 4, 7], [1, 
//   2, 5, 6], [1, 2, 5, 7], [1, 2, 6, 7], [1, 3, 4, 5], [1, 3, 4, 
//   6], [1, 3, 4, 7], [1, 3, 5, 6], [1, 3, 5, 7], [1, 3, 6, 7], [1, 4, 
//   5, 6], [1, 4, 5, 7], [1, 4, 6, 7], [1, 5, 6, 7], [2, 3, 4, 5], [2, 
//   3, 4, 6], [2, 3, 4, 7], [2, 3, 5, 6], [2, 3, 5, 7], [2, 3, 6, 
//   7], [2, 4, 5, 6], [2, 4, 5, 7], [2, 4, 6, 7], [2, 5, 6, 7], [3, 4, 
//   5, 6], [3, 4, 5, 7], [3, 4, 6, 7], [3, 5, 6, 7], [4, 5, 6, 7]
// ];

// var perm5 =  [
//   [0, 1, 2, 3, 4], [0, 1, 2, 3, 5], [0, 1, 2, 3, 6], [0, 1, 2, 3, 
//   7], [0, 1, 2, 4, 5], [0, 1, 2, 4, 6], [0, 1, 2, 4, 7], [0, 1, 2, 5, 
//   6], [0, 1, 2, 5, 7], [0, 1, 2, 6, 7], [0, 1, 3, 4, 5], [0, 1, 3, 4, 
//   6], [0, 1, 3, 4, 7], [0, 1, 3, 5, 6], [0, 1, 3, 5, 7], [0, 1, 3, 6, 
//   7], [0, 1, 4, 5, 6], [0, 1, 4, 5, 7], [0, 1, 4, 6, 7], [0, 1, 5, 6, 
//   7], [0, 2, 3, 4, 5], [0, 2, 3, 4, 6], [0, 2, 3, 4, 7], [0, 2, 3, 5, 
//   6], [0, 2, 3, 5, 7], [0, 2, 3, 6, 7], [0, 2, 4, 5, 6], [0, 2, 4, 5, 
//   7], [0, 2, 4, 6, 7], [0, 2, 5, 6, 7], [0, 3, 4, 5, 6], [0, 3, 4, 5, 
//   7], [0, 3, 4, 6, 7], [0, 3, 5, 6, 7], [0, 4, 5, 6, 7], [1, 2, 3, 4, 
//   5], [1, 2, 3, 4, 6], [1, 2, 3, 4, 7], [1, 2, 3, 5, 6], [1, 2, 3, 5, 
//   7], [1, 2, 3, 6, 7], [1, 2, 4, 5, 6], [1, 2, 4, 5, 7], [1, 2, 4, 6, 
//   7], [1, 2, 5, 6, 7], [1, 3, 4, 5, 6], [1, 3, 4, 5, 7], [1, 3, 4, 6, 
//   7], [1, 3, 5, 6, 7], [1, 4, 5, 6, 7], [2, 3, 4, 5, 6], [2, 3, 4, 5, 
//   7], [2, 3, 4, 6, 7], [2, 3, 5, 6, 7], [2, 4, 5, 6, 7], [3, 4, 5, 6, 
//   7]
// ];

// var perm6 =  [
//   [0, 1, 2, 3, 4, 5], [0, 1, 2, 3, 4, 6], [0, 1, 2, 3, 4, 7], [0, 1, 2,
//    3, 5, 6], [0, 1, 2, 3, 5, 7], [0, 1, 2, 3, 6, 7], [0, 1, 2, 4, 5, 
//   6], [0, 1, 2, 4, 5, 7], [0, 1, 2, 4, 6, 7], [0, 1, 2, 5, 6, 7], [0, 
//   1, 3, 4, 5, 6], [0, 1, 3, 4, 5, 7], [0, 1, 3, 4, 6, 7], [0, 1, 3, 5,
//    6, 7], [0, 1, 4, 5, 6, 7], [0, 2, 3, 4, 5, 6], [0, 2, 3, 4, 5, 
//   7], [0, 2, 3, 4, 6, 7], [0, 2, 3, 5, 6, 7], [0, 2, 4, 5, 6, 7],
//   [7,6, 5, 4, 3, 0], [4, 5, 6, 1, 2, 3], [7, 5, 4, 3, 2, 1], [4, 6, 7, 1,  2, 3],  
//  [7, 6, 5, 3, 2, 1], [7, 6, 5, 4, 2, 1], [1, 3, 4, 5, 6, 7], [2, 3, 4, 5, 6, 7]
// ];

// // select: for each permutation, select the zones that apply (16 zones)

// var select3 =  null;
// var select4 =  null;
// var select5 =  null;

// var select6 =  [
//   [3, 4, 11, 12],    [15, 0, 7, 8],    [13, 14, 5, 6],    [1, 2, 9, 10],    [15, 0, 7, 8],    [3, 4, 11, 12],    [8, 9, 10, 11],    
//   [3, 4, 11, 12],    [15, 0, 7, 8],    [1, 2, 9, 10],    [3, 4, 11, 12],    [4, 5, 6, 7],    [13, 14, 5, 6],    [15, 0, 7, 8],    
//   [3, 4, 11, 12],    [15, 0, 7, 8],    [13, 14, 5, 6],    [12, 13, 14, 15],    [3, 4, 11, 12],    [15, 0, 7, 8],    [13, 14, 5, 6],    
//   [1, 2, 9, 10],    [15, 0, 7, 8],    [3, 4, 11, 12],    [0, 1, 2, 3],    [1, 2, 9, 10],    [15, 0, 7, 8],    [3, 4, 11, 12]  ];



// file smt_searchmethod.pde

//Shot shot_marc[][] = new Shot[70][shot_n]; // large enough to hold one for each permutations
var shot_marc=[];
for (var i = 0; i < 70; i++) shot_marc[i]= [];


// from file smt_searchmethod.pde (it really doesn't belong there!!)



// function getPermList(pos, n_params) { // only used by compute_marcsearch
// //var sol =  new $p.ArrayList();
//   var sol=[];

//   var perm =  null;
//   var select =  null;
//   if (n_params == 3) {
//     perm = perm3;
//     select = select6; // DMC 10 May 2017 - hard to believe it, but YES this is in the original source code
//   } else if (n_params == 4) {
//     perm = perm4;
//     select = select4;
//   } else if (n_params == 5) {
//     perm = perm5;
//     select = select5;
//   } else if (n_params == 6) {
//     perm = perm6;
//     select = select6;
//   }

//   if (n_params == 6) {
//     //var middle =  pos.dist(new XYZ(0, 0)) < 2 * moa_cm;
//     // boolean middle = pos.dist(new XYZ(0, 0)) < 2 * moa_cm;
//     var middle = true; // HARDCODING we need to fix this!!

//     if (middle) {
// /*
// sol.add(new Integer(6));
//       sol.add(new Integer(11));
//       sol.add(new Integer(17));
//       sol.add(new Integer(24));
//       return sol;
// */
//       sol.push(6); sol.push(11); sol.push(17); sol.push(24);
//       return sol;
//     }

//     var x =  pos.x;
//     var y =  pos.y;
//     var angle =  Math.atan2(x*2, y);
//     if (angle < 0) angle += 2*Math.PI;
//     var zone =  Math.floor(angle / (Math.PI/8));

//     for (var m =  0;  m < select.length;  m++) {
//       for (var n =  0;  n < select[m].length;  n++) {
//         if (select[m][n] == zone && (sol.indexOf(m) == -1)) {
//           sol.push(m);
//         }
//       }
//     }
//   } else { // n_params != 6
//     for (var i =  0;  i < perm.length;  i++) {
//       sol.push(i);
//     }
//   }

//   return sol;
// }




// util.pde


var XYZ = (function() {
function XYZ() {
var $this_1 = this;
function $superCstr(){$p.extendClassChain($this_1)}
$this_1.x = null;
$this_1.y = null;
$this_1.z = null;
function toString$0_NaN() {
return $this_1.x + ", " + $this_1.y + ", " + $this_1.z;
}
$p.addMethod($this_1, 'toString', toString$0_NaN, false);
function dist$1(b) {
return sqrt(($this_1.x - b.x)*($this_1.x - b.x) + ($this_1.y - b.y)*($this_1.y - b.y) + ($this_1.z - b.z)*($this_1.z - b.z));
}
$p.addMethod($this_1, 'dist', dist$1, false);
function len$0() {
return sqrt($this_1.x*$this_1.x + $this_1.y*$this_1.y + $this_1.z*$this_1.z);
}
$p.addMethod($this_1, 'len', len$0, false);
function norm$0() {
var v =  $this_1.$self.len();
    $this_1.x /= v;
    $this_1.y /= v;
    $this_1.z /= v;
}
$p.addMethod($this_1, 'norm', norm$0, false);
function $constr_0(){
$superCstr();

$this_1.x = 0;
    $this_1.y = 0;
    $this_1.z = 0;
}

function $constr_1(b){
$superCstr();

$this_1.x = b.x;
    $this_1.y = b.y;
    $this_1.z = b.z;
}

function $constr_2(x, y){
$superCstr();

$this_1.x = x;
    $this_1.y = y;
    $this_1.z = 0;
}

function $constr_3(x, y, z){
$superCstr();

$this_1.x = x;
    $this_1.y = y;
    $this_1.z = z;
}

function $constr() {
if(arguments.length === 0) { $constr_0.apply($this_1, arguments); } else if(arguments.length === 1) { $constr_1.apply($this_1, arguments); } else if(arguments.length === 2) { $constr_2.apply($this_1, arguments); } else if(arguments.length === 3) { $constr_3.apply($this_1, arguments); } else $superCstr();
}
$constr.apply(null, arguments);
}
return XYZ;
})();
$p.XYZ = XYZ;

function sqrt(x) {
return Math.sqrt(x);
}
$p.sqrt = sqrt;

function abs(x) {
return Math.abs(x);
}
$p.abs = abs;

function round(x) {
return Math.round(x);
}
$p.round = round;

function constrain(x, low, high) {
if (x < low) x = low;
  if (x > high) x = high;
  return x;
}
$p.constrain = constrain;

function random(low, high) {
return random(low, high);
}
$p.random = random;

function point(x, y) {
point(x, y);
}
$p.point = point;

function point(x, y, z) {
point(x, y, z);
}
$p.point = point;

function line(x1, y1, x2, y2) {
line(x1, y1, x2, y2);
}
$p.line = line;

function line(x1, y1, z1, x2, y2, z2) {
line(x1, y1, z1, x2, y2, z2);
}
$p.line = line;

function rect(x, y, w, h) {
rect(x, y, w, h);
}
$p.rect = rect;

function circle(x, y, d) {
$p.ellipse(x, y, d, d);
}
$p.circle = circle;

function text_mm(str, x, y) {
$p.pushMatrix();
  $p.translate(x, y);
  $p.scale(1, -1);
  $p.text(str, 0, 0);
  $p.popMatrix();
}
$p.text_mm = text_mm;

function atoi(str) {
try {
return Integer.parseInt(str);
} catch (e) {
return 0;
}
}
$p.atoi = atoi;

function atof(str) {
try {
return Float.parseFloat(str);
} catch (e) {
return 0;
}
}
$p.atof = atof;

function atod(str) {
try {
return Double.parseDouble(str);
} catch (e) {
return 0;
}
}
$p.atod = atod;

function min(a, b) {
return (a < b)?(a):(b);
}
$p.min = min;

function max(a, b) {
return (a > b)?(a):(b);
}
$p.max = max;

function sin(x) {
return Math.sin(x);
}
$p.sin = sin;

function cos(x) {
return Math.cos(x);
}
$p.cos = cos;

function tan(x) {
return Math.tan(x);
}
$p.tan = tan;

function asin(x) {
return Math.asin(x);
}
$p.asin = asin;

function acos(x) {
return Math.acos(x);
}
$p.acos = acos;

function atan(x) {
return Math.atan(x);
}
$p.atan = atan;

function pow(a, b) {
return Math.pow(a, b);
}
$p.pow = pow;

 function getColor(v) {
v = constrain(v, 0, 1);
  var hue =  $p.map(v, 0, 1, 0.4, 0);
  var sat =  1.0;
  var lum =  0.5;
  var a =  1;
  return hsla2rgba(hue, sat, lum, a);
}
$p.getColor = getColor;

function hsla2rgba(hue, sat, lum, a) {
var r = 0,g = 0,b = 0;

  if (sat == 0) {
r = lum;        g = lum;
      b = lum;
} else {
var q =  lum < 0.5 ? (lum * (1 + sat)) : (lum + sat - lum * sat);
      var p =  2 * lum - q;
      r = hue2rgb(p, q, hue + 1/3);
      g = hue2rgb(p, q, hue);
      b = hue2rgb(p, q, hue - 1/3);
}

  return getColor($p.__int_cast((r * 255)), $p.__int_cast((g * 255)), $p.__int_cast((b * 255)), $p.__int_cast((a * 255)));
}
$p.hsla2rgba = hsla2rgba;

function hue2rgb(p, q, t) {
if(t < 0) t += 1;
  if(t > 1) t -= 1;
  if(t < 1/6) return p + (q - p) * 6 * t;
  if(t < 1/2) return q;
  if(t < 2/3) return p + (q - p) * (2/3 - t) * 6;
  return p;
}
$p.hue2rgb = hue2rgb;

function getColor(r, g, b, a) {
return (a & 0xFF) << 24 | (r & 0xFF) << 16 | (g & 0xFF) << 8 | (b & 0xFF);
}
$p.getColor = getColor;

/*
var format1 =  new DecimalFormat("0.0");
var format2 =  new DecimalFormat("0.00");
var format3 =  new DecimalFormat("0.000");
*/

function dec1(v) {
return format1.format(v);
}
$p.dec1 = dec1;

function dec2(v) {
return format2.format(v);
}
$p.dec2 = dec2;

function dec3(v) {
return format3.format(v);
}
$p.dec3 = dec3;











/*
var xx = new XYZ(1,2,3);
console.log("DMC---",xx);
console.log("DMC--len",xx.len()); // works
*/
//console.log("DMC--norm",xx.norm()); // does not work; $p.addMethod needs work.
/*
/d2/home/dmc/work2/smtv2-lodi/calc_shot_nr.js:234
var v =  $this_1.$self.len();
                       ^
TypeError: Cannot call method 'len' of undefined

*/


  var Pt0 =  new Params();    var Pt =  new Params();
   Pt0.p1 = 32;
    Pt.copyFrom(Pt0);
   Pt0.p1 = 33;

//console.log("DMC-Params-Pt0",Pt0);
//console.log("DMC-Params-Pt",Pt);


//console.log("DMC-compute",compute());

//var xx = new XYZ();






//console.log("Daniel, util.pde",$p.pow(2,5),new XYZ(1,2,3));

exports.solve_nr_8mic_cube = function(shot /* we create shot.res_nr */) { // special case: conventional SMT 8-mic "cube" geometry.

	// for now, to avoid cloning code in calc_shot.js:calc_initial(), we use incoming values to set our global vars:
	v_sound = shot.res.soundspeed;
//	clock = shot.res.clock; // effing cms

//console.log("DMC clock=",clock); process.exit(1);
	
//console.log("DMC debug solve_nr_8mic_cube incoming shot=",shot);
	// output directly to shot itself
	var res = shot.res_nr = {};

	var spacing = shot.geom.chrono_spacing*effingmm_to_cm;
	var mic_w = shot.geom.mic_width*effingmm_to_cm;
	var mic_h = shot.geom.mic_height*effingmm_to_cm;

	// mic geometry

	var mic_pos_nominal = [ // conventional SMT layout
		new XYZ(-mic_w/2, -mic_h/2, 0), // mic1 bot left back
		new XYZ(-mic_w/2,  mic_h/2, 0), // mic2 top left back
		new XYZ(-mic_w/2, -mic_h/2, spacing), // mic3 bot left front
		new XYZ( mic_w/2,  mic_h/2, 0), // mic4 top right back
		new XYZ( mic_w/2, -mic_h/2, 0), // mic5 bot right back
		new XYZ(-mic_w/2,  mic_h/2, spacing), // mic6 top left front
		new XYZ( mic_w/2,  mic_h/2, spacing), // mic7 top right front
		new XYZ( mic_w/2, -mic_h/2, spacing), // mic8 bot right front
	];
	// SET GLOBAL
	mic_n = mic_pos_nominal.length;

	// mic timing values

  var mic_map= mic_mapping.get_mic_mapping(shot);
	res.mic_mapping = mic_map;
	var logical_mics_in_use = mic_mapping.logical_mics_in_use(mic_map); // used below...
	var mic_timing = res.mic = mic_mapping.phys_to_logical(mic_map,shot.shot.counters);

  // at this point, mic coords are in conventional SMT layout, and we have the corresponding
	// mic timings available in mic_timings[]

	var map_smt_to_adam = [
		1-1, // Adam mic1 is SMT mic1
		5-1, // Adam mic2 is SMT mic..
		2-1, // Adam mic3 is SMT mic..
		4-1, // Adam mic4 is SMT mic..
		3-1, // Adam mic5 is SMT mic..
		8-1, // Adam mic6 is SMT mic..
		6-1, // Adam mic7 is SMT mic..
		7-1, // Adam mic8 is SMT mic..
	];
	var mic_pos_nominal_adam = [], mic_timing_adam = [];
	for (var i in mic_pos_nominal) {
		mic_pos_nominal_adam[i] = mic_pos_nominal[map_smt_to_adam[i]];
		mic_timing_adam[i] = mic_timing[map_smt_to_adam[i]];
	}
//console.log("DMC-solve_nr parms std mic timings",mic_timing);
//console.log("DMC-solve_nr parms adam mic timings",mic_timing_adam);
//console.log("DMC-solve_nr parms adam mic positions",mic_pos_nominal_adam);
//process.exit();
//console.log("DMC-solve_nr parms",s1);


	var s1 =  new Shot; //(i);
	s1.mic = mic_timing_adam;
	s1.mic_smt = mic_timing;
//console.log("DMC-solve_nr parms",s1);

	s1.compute(mic_pos_nominal_adam, s1.mic); // calls compute$2
//console.log("DMC-solve_nr shot.compute() done, shot=",s1);

	// output
	res.xy_valid = s1.valid;
	if (res.xy_valid) {
		res.x = s1.pos.x; res.y = s1.pos.y;
		res.v = s1.vel;
		res.theta = s1.theta; res.phi = s1.phi;
		res.soundspeed = shot.res.soundspeed; // copy from incoming "shot.res"
		res.temp = shot.res.temp; res.temp_invalid = shot.res.temp_invalid;
//		res.xy_error = ;
		res.mic = mic_timing; // res.mic_mapping is already set
		res.avg_count = s1.avg_count;
		res.perms_used_DMC_DEBUG = s1.perms_used_DMC_DEBUG;

	} else { // invalid shot
		res.v = s1.vel; // ??
	}

}

exports.solve_nr_hbar = function(shot /* we create shot.res_hbar */) { // special case: HBAR geometry.

	// for now, to avoid cloning code in calc_shot.js:calc_initial(), we use incoming values to set our global vars:
	v_sound = shot.res.soundspeed;
//	clock = shot.res.clock; // effing cms
	
//console.log("DMC debug solve_nr_hbar incoming shot=",shot);
	// output directly to shot itself
	var res = shot.res_hbar = {};

	// determine mic mapping - shift timings to different mic positions
	// use default, or global setting, or frame overrides
	res.mic_mapping = mic_mapping.get_mic_mapping(shot);
	var logical_mics_in_use = mic_mapping.logical_mics_in_use(mic_mapping.get_mic_mapping(shot)); // used below...
	var mic_timing = res.mic = mic_mapping.phys_to_logical(res.mic_mapping,shot.shot.counters);
	var mic_pos = mic_mapping.get_mic_pos(shot); // fetch canonical mic positions
	// SET GLOBAL
	mic_n = mic_pos.length;

	// at this point, mic coords are in conventional SMT layout, and we have the corresponding
	// mic timings available in mic_timing[]

// console.log("DMC-solve_nr_hbar parms physical mic timings",mic_timing);
// console.log("DMC-solve_nr_hbar incoming shot.shot.counters",shot.shot.counters);
// console.log("DMC-solve_nr_hbar mic_pos",mic_pos);
//console.log("DMC-solve_nr parms adam mic timings",mic_timing_adam);
//console.log("DMC-solve_nr parms adam mic positions",mic_pos_nominal_adam);
//process.exit();
//console.log("DMC-solve_nr parms",s1);


	var s1 =  new Shot; //(i);
	s1.mic = mic_timing;

//	s1.mic = mic_timing_adam;
//	s1.mic_smt = mic_timing;
//console.log("DMC-solve_nr parms",s1);

	res.soundspeed = shot.res.soundspeed; // copy from incoming "shot.res
	res.temp = shot.res.temp; res.temp_invalid = shot.res.temp_invalid;

	s1.compute_hbar(mic_pos, s1.mic, res, shot.geom);

//console.log("DMC-solve_nr_hbar shot.compute_hbar() done, shot=",s1);

	// output
	res.xy_valid = s1.valid; // needs work; for a mic tap, we are getting xy_valid == true
	if (res.xy_valid) {
		res.x = s1.pos.x + shot.geom.x_cal; // adjust for x_cal and y_cal
		res.y = s1.pos.y + shot.geom.y_cal; // adjust for x_cal and y_cal
		res.v = s1.vel;
		res.theta = s1.theta; res.phi = s1.phi;
//		res.xy_error = ; // not applicable for NR solution; maybe use timing_error2 instead
		res.mic = mic_timing; // res.mic_mapping is already set
//		res.avg_count = s1.avg_count;
		res.perms_used_DMC_DEBUG = s1.perms_used_DMC_DEBUG;
		res.calcd_t0 = trim_num(s1.t0); // mostly for debugging
		// check for missing mics in chrono-pairs
		if (logical_mics_in_use[1-1] && logical_mics_in_use[3-1]) {
			if ( !res.raw_v13) shot.whack_raw_v = true;
		}
		if (logical_mics_in_use[2-1] && logical_mics_in_use[6-1]) {
			if ( !res.raw_v26) shot.whack_raw_v = true;
		}
		if (logical_mics_in_use[4-1] && logical_mics_in_use[7-1]) {
			if ( !res.raw_v47) shot.whack_raw_v = true;
		}
		if (logical_mics_in_use[5-1] && logical_mics_in_use[8-1]) {
			if ( !res.raw_v58) shot.whack_raw_v = true;
		}

  	// shot.is_starred is now done by calc_scorezone
		// shot.is_starred = shot.whack_raw_v || shot.whack_v || shot.whack_xy_err || shot.whack_v_err;

	} else { // invalid shot
		res.v = s1.vel; // ??
	}

}

