/*******************************************************************************
 $Author: dmc $
 $Revision: 3206 $
 $Date: 2023-07-06 10:53:57 -0300 (Thu, 06 Jul 2023) $
 $HeadURL: http://support2.silvermountaintargets.com/svn/smt/smtv2-lodi/public/javascripts/viewer_toolbar_match.js $
*******************************************************************************/

var toolbar_match = new function() {
	
	this.match_list = null;
	this.stage_list = null;

	this.init = function() {
		this.icon = $("<img src='images/admin_match.png' class='toolbar_icon'>");
		this.admin_icon = $("<img src='images/admin_face.png' class='toolbar_icon inline_icon'>").css("padding", "3px");
	}
	
	// whether icon should be shown on main toolbar
	this.ready = function() {
        if (toolbar_military.is_mil()) return false;
		// return admin_check() || ro_check() || extended_check();
		return admin_check() || ro_check();
	}
	
	// try to open this panel (return false to cancel)
	this.show = function() {
		return true;
	}
	
	// try to close this panel (return false to cancel)
	this.hide = function () {
		return true;
	}

	// display the panel in the supplied div
	this.draw = function (div) {

		this._drawRO(div);

		// if (admin_check() || ro_check()) {
		// 	this._drawRO(div);
		// } else if (extended_check()) {
		// 	this._drawExtended(div);
		// }

	}

	this._drawExtended = function(div) {
		toolbar_match.draw_freeformDefinedCourseOfFireButtons(div);
		toolbar_match.draw_chooseCourseOfFire(div);
	}

	this._drawRO = function(div) {
		toolbar.new_button(div, S("MATCH_SAVE_ALL_TARGETS"), function () {
			var name = prompt(S("MATCH_SAVE_ALL_TARGETS_PROMPT"));
			if (name == null) return;

			for (var i in g_strings) {
				var str = g_strings[i];
				if (str.frame().data.enabled && str.frame().string().id() == str.id()) {
					save_string(str, name);
				}
			}
		});
		//		div.append("<br>");

        if (!g_config.is_NRA) {
			// toolbar_match.draw_readytgts(div);
			div.append("<hr>");

			toolbar_match.draw_xStuff(div);
			div.append("<hr>");
			toolbar_match.draw_eventStuff(div);
			div.append("<hr>");

			toolbar_match.draw_freeformDefinedCourseOfFireButtons(div);
		}
		div.append("<br>");
		toolbar_match.draw_chooseCourseOfFire(div);

		div.append("<hr>");
		if (!g_config.is_NRA) {
				toolbar.new_button(div, S("MATCH_USE_ASSIGNED_SHOOTERS"), function() { // todo
				config_crud({ use_role_shooter: !g_config.use_role_shooter });
			}, g_config.use_role_shooter);

			toolbar.new_button(div, S("MATCH_USE_ASSIGNED_SCOREKEEPERS"), function() { // todo
				config_crud({ use_role_scorer: !g_config.use_role_scorer });
			}, g_config.use_role_scorer);

			div.append("<br>");
			toolbar_match.draw_shotDelayButtons(div);
		}
		div.append("<br>");
		toolbar_match.draw_shotListOptionButtons(div);
		div.append("<br>");
		// display options
		toolbar.new_text(div, S("MATCH_MANAGING_STRINGS"));

		// all users, even spectators, for freeform
		toolbar.new_button(div, S("MATCH_EVERYONE"), function() {
			config_crud({ option_access_mode: 0 });
		}, !g_config.option_access_mode);

		// users must at least be assigned as a shooter/scorer
		toolbar.new_button(div, S("MATCH_ASSIGNED_SHOOTER"), function() {
			config_crud({ option_access_mode: 1 });
		}, g_config.option_access_mode == 1);

		// only the scorekeeper (and RO)
		toolbar.new_button(div, S("MATCH_SCOREKEEPER"), function() {
			config_crud({ option_access_mode: 2 });
		}, g_config.option_access_mode == 2);
		
		// only the RO (scorers and shooters restricted)
		toolbar.new_button(div, S("MATCH_RO_ONLY"), function() {
			config_crud({ option_access_mode: 3 });
		}, g_config.option_access_mode == 3);

		div.append("<br>");

		if (!g_config.is_NRA) {
			// freeform mode: spectators can save strings
			toolbar.new_checkbox(div, S("MATCH_SCORECARDS_NEEDED"), function() {
				config_crud({ option_must_accept: !g_config.option_must_accept });
			}, g_config.option_must_accept);
			// freeform mode: spectators can save strings

			div.append("<br>");

			// freeform mode: spectators can save strings
			toolbar.new_checkbox(div, S("MATCH_USER_ASSIGN_STRING"), function() {
				config_crud({ users_can_assign: !g_config.users_can_assign });
			}, g_config.users_can_assign);

			div.append("<hr>");
		}
		toolbar_system.draw_div_backup(div);
		toolbar_system.draw_div_restore(div);

		toolbar_system.draw_div_shutdown(div); // shutdown server
	}
}

toolbar_match.draw_readytgts = function (div) {
	var header = toolbar.new_text(div, "");
	var ready_count = 0;
	var total_count = 0;
	
	// todo: sort these
	targetlist = [];
	for (var i in g_strings) {
		var str = g_strings[i];
		if (str.frame().data.enabled && str.frame().string().id() == str.id()) {
			targetlist.push(str.id());
		}
	}
	
	targetlist.sort(function(a,b) {
		var t1 = g_strings[a].frame().data.name;
		var t2 = g_strings[b].frame().data.name;
		if (t1 < t2) return -1;
		if (t1 > t2) return 1;
		return 0;
	});
	
	var readydiv = $("<div>");
	readydiv.css("overflow-y", "scroll");
	readydiv.css("margin-left", "30px");
	readydiv.css("max-height", 200);
	
	// enable scrolling
	readydiv.bind("touchstart", function(e) { e.originalEvent.allow_touchstart = true; });
	readydiv.bind("touchmove", function(e) { e.originalEvent.allow_touchmove = true; });
	
	div.append(readydiv);
	var selected_button = null;

	for (var i in targetlist) {
		var str = g_strings[targetlist[i]];
		
		var ready = get_target_ready_status(str.id());

		if (ready.status != 0) ready_count++;
		else {
			
			var selected = (str.id() == cur_string().id());
			
			var item = toolbar.new_button(readydiv, str.frame().data.name, function() {
				targetrow.selectFrame(this.arg.frame().id());
				if (toolbar.back()) toolbar.set_panel(toolbar_string);
				update();
			}, selected);
			item[0].arg = str.id();

			if (selected) selected_button = item;
			
			var item = toolbar.new_text(readydiv, ready.text);
			item.addClass(ready.css);
			readydiv.append("<br>");

			
		}
		
	}

	if (selected_button) {		
		readydiv.scrollTop(selected_button[0].offsetTop - readydiv.height() / 2);
	}
	
	header.text(S("MATCH_TARGETS_READY", ready_count, targetlist.length));
}

toolbar_match.draw_eventStuff = function (div) {
	toolbar.new_checkbox(div, S("match_event"), function () {
		config_crud({ event_enabled: !g_config.event_enabled, event_data: { event_id: -1, match_id: -1, stage_id: -1 } });
	}, g_config.event_enabled);

	// using rstat events: display match and stage selection
	if (g_config.event_enabled) {

		var list = [];
		list.push({ value: -1, text: S("match_event_select") });
		list.push({ value: -2, text: S("match_event_new") });
		for (i in g_events) {
			var event = g_events[i];
			list.push({ value: event.id, text: event.name });
		}

		toolbar.new_dropdown(div, list, function (item) {

			if (item.val() == -2) {
				var str = prompt(S("match_event_name_prompt"));
				if (str) {

					// create event
					var id = get_unique_id();
					var msg = new_crud();
					msg.events[id] = {
						id: id,
						name: str,
						matches: {}
					};
					g_socket.emit("crud", msg);
					config_crud({
						event_data: {
							event_id: id,
							event_str: str,
							match_id: -1,
							stage_id: -1
						}
					});
				}
				return;
			}

			var str = S("match_match_none");
			if (g_events[item.val()]) str = g_events[item.val()].name;
			config_crud({
				event_data: {
					event_id: item.val(),
					event_str: str,
					match_id: -1,
					stage_id: -1
				}
			});
		}, g_config.event_data.event_id);

		if (g_config.event_data.event_id >= 0) {

			var event = g_events[g_config.event_data.event_id];

			var list = [];
			list.push({ value: -1, text: S("match_match_select") });
			list.push({ value: -2, text: S("match_match_new") });
			for (i in event.matches) {
				var match = event.matches[i];
				list.push({ value: match.id, text: match.name });
			}

			toolbar.new_dropdown(div, list, function (item) {

				if (item.val() == -2) {
					var str = prompt(S("match_match_name_prompt"));
					if (str) {

						// create match
						var id = get_unique_id();
						var match = {
							id: id,
							name: str,
							stages: {}
						};
						var msg = new_crud();
						msg.events[g_config.event_data.event_id] = { matches: {} };
						msg.events[g_config.event_data.event_id].matches[id] = match;
						g_socket.emit("crud", msg);
						config_crud({
							event_data: {
								match_id: id,
								match_str: str,
								stage_id: -1
							}
						});
					}
					return;
				}

				var str = S("match_match_none");
				if (event.matches[item.val()]) str = event.matches[item.val()].name;
				config_crud({
					event_data: {
						match_id: item.val(),
						match_str: str,
						stage_id: -1
					}
				});
			}, g_config.event_data.match_id);

			if (g_config.event_data.match_id >= 0) {
				var match = event.matches[g_config.event_data.match_id];

				var list = [];
				list.push({ value: -1, text: S("match_stage_select") });
				list.push({ value: -2, text: S("match_stage_new") });
				if (match && match.stages) {
					for (i in match.stages) {
						var stage = match.stages[i];
						list.push({ value: stage.id, text: stage.name });
					}
				}

				toolbar.new_dropdown(div, list, function (item) {

					if (item.val() == -2) {
						var str = prompt(S("match_stage_name_prompt"));
						if (str) {

							// parse distance
							var dist = 0;
							var list = str.replace(/\D/g, ',').split(',');
							console.log(list);
							for (i in list) {
								var num = Number(list[i]);
								if (num > 20) { dist = num; break; }
							}
							if (dist == 0) {
								var list = match.name.replace(/\D/g, ',').split(',');
								for (i in list) {
									var num = Number(list[i]);
									if (num > 20) { dist = num; break; }
								}
							}

							// create stage
							var id = get_unique_id();
							var stage = {
								id: id,
								name: str,
								distance: dist
							};
							var msg = new_crud();
							msg.events[g_config.event_data.event_id] = { matches: {} };
							msg.events[g_config.event_data.event_id].matches[g_config.event_data.match_id] = { stages: {} };
							msg.events[g_config.event_data.event_id].matches[g_config.event_data.match_id].stages[id] = stage;
							g_socket.emit("crud", msg);
							config_crud({
								event_data: {
									stage_id: id,
									stage_str: str
								}
							});
						}
						return;
					}

					var str = S("match_match_none");
					if (match.stages[item.val()]) str = match.stages[item.val()].name;
					config_crud({
						event_data: {
							stage_id: item.val(),
							stage_str: str
						}
					});
				}, g_config.event_data.stage_id);

				// button to select target faces
				if (g_config.event_data.stage_id >= 0) {

					var stage = match.stages[g_config.event_data.stage_id];

					if (stage.distance > 20) {

						var selected_face = null;

						for (i in g_faces) {
							var dist_metres = g_faces[i].data.distance;
							var dist_yards = dist_metres * 3.28 / 3;
							if (g_faces[i].data.enabled && (abs(dist_metres - stage.distance) < 1 || abs(dist_yards - stage.distance) < 1)) {
								selected_face = i;
								break;
							}
						}

						if (selected_face) {
							toolbar.new_button(div, g_faces[selected_face].data.name, function () {
								if (confirm(S("FACE_SELECT_ALL_CONFIRM"))) {
									for (var i in g_strings) {
										var str = g_strings[i];
										if (str.frame().data.enabled && str.frame().string().id() == str.id()) {
											str.crud({ face_id: selected_face });
											g_socket.emit("recalc_shot_scores", str.id());
											g_socket.emit("update_string_stats", str.id());
										}
									}
								}
							}, cur_string().face().id() == selected_face);
						}

					}

				}

			}

			var regcount = numberof(event.shooters); // returns 0 if array does not exist
			div.append("<br>");
			toolbar.new_text(div, S("match_number_of_registered_shooters") + regcount);

			if (regcount > 0) {

				var event_log = [];

				// check guntype on all registered shooters
				for (var i in event.shooters) {
					var user = g_users[i];
					var guntype = event.shooters[i].guntype;

					var fclass = (guntype == "FO" || guntype == "FTR" || guntype == "OPN" || guntype == "TR" || guntype == "F");
					var sling = (guntype == "PR" || guntype == "SVR" || guntype == "ARO" || guntype == "FRI" || guntype == "MR");

					if (!fclass && !sling) {
						event_log.push("Shooter " + user.data.name + " (" + user.data.realname + ") has invalid GunCat");

					} else { // check and update user f-class setting
						if (fclass && !user.data.fclass_target) user.crud({ fclass_target: 1 });
						else if (sling && user.data.fclass_target) user.crud({ fclass_target: 0 });
					}

				}

				if (event_log.length > 0) {
					var msglog = $("<div>");
					msglog.css("font-size", "12px");
					msglog.css("background-color", "#eee");
					msglog.css("color", "black");
					for (i in event_log) {
						msglog.append(event_log[i]);
						msglog.append("<br>");
					}
					div.append(msglog);
				}

			}

			div.append("<br>");
			toolbar.new_button(div, S("match_delete_event"), function () {
				if (confirm(S("match_delete_event_confirm"))) {
					g_socket.emit("event_delete", g_config.event_data.event_id);
				}
			});


			// display event results
			if (g_config.event_enabled && g_config.event_data.event_id >= 0) {
				var event = g_events[g_config.event_data.event_id];

				var text = event.name;
				var match = event.matches[g_config.event_data.match_id];
				if (match  && g_config.event_data.match_id >= 0) {
					text += ", " + match.name;
					if (g_config.event_data.stage_id >= 0) {
						text += ", " + match.stages[g_config.event_data.stage_id].name;
					} else {
						text += ", " + S("match_all_stages");
					}
				} else {
					text += ", " + S("match_all_matches");
				}

				toolbar.new_button(div, S("match_results"), function () {
					g_socket.emit("generate_results", g_config.event_data.event_id, g_config.event_data.match_id, g_config.event_data.stage_id);
				});
				toolbar.new_text(div, "(" + text + ")");

			}
		}

	}

}

function is_experimental() {
	return g_config.experimental_features && g_config.experimental_features.enabled;
}

function is_validshots() { // use string.shots[...] or string.validshots[..] ?
	return !!
	(g_config.experimental_features && g_config.experimental_features.enabled
	&& g_config.experimental_features.validshots
	);
}

toolbar_match.draw_xStuff = function (div) {
	if (!g_config.experimental_features) g_config.experimental_features = {};
	toolbar.new_checkbox(div, "Experimental", function () {
		config_crud({ experimental_features: { enabled: !g_config.experimental_features.enabled } });
	}, g_config.experimental_features.enabled);

	if (g_config.experimental_features.enabled) {

		toolbar.new_button(div, "highperf", function () {
			config_crud({ experimental_features: { highperf: !g_config.experimental_features.highperf } });
		}, g_config.experimental_features.highperf);

		toolbar.new_button(div, "validshots", function () {
			config_crud({ experimental_features: { validshots: !g_config.experimental_features.validshots } });
		}, g_config.experimental_features.validshots);

	}
}

toolbar_match.draw_freeformDefinedCourseOfFireButtons = function (div) {
	toolbar.new_button(div
		, S("match_freeform_shooting")
		, function () { config_crud({ basic_mode: !g_config.basic_mode, sighter_count: 0 }); }
		, g_config.basic_mode);
	toolbar.new_button(div
		, S("match_defined_course_of_fire")
		, function () { config_crud({ basic_mode: !g_config.basic_mode }); }
		, !g_config.basic_mode);
	div.append("<br>");
}

toolbar_match.draw_chooseCourseOfFire = function (div) {
	if (g_config.basic_mode) {
		toolbar.new_text(div, S("match_shots_within"));


		var delays_modes = [{ count: 5, text: "5s" },
		{ count: 10, text: "10s" }];

		var use_other = true; // whether sighter count is 'other'
		if (undefined == g_config.basic_mode_delay) g_config.basic_mode_delay = 5;
		for (var delays_i in delays_modes) {
			var mode = delays_modes[delays_i];

			var item = toolbar.new_button(div, mode.text, function () {
				config_crud({ basic_mode_delay: this.arg });
			}, g_config.basic_mode_delay == mode.count);
			item[0].arg = mode.count;

			if (g_config.basic_mode_delay == mode.count) use_other = false;
		}

		// fix when value is invalid
		if (use_other && g_config.basic_mode_delay < 0) {
			config_crud({ basic_mode_delay: 5 }); // set to default
			use_other = false;
		}

		// other button
		toolbar.new_button(div, (use_other) ? ("(" + g_config.basic_mode_delay + ")s") : ("(...)"), function () {
			var result = prompt(S("match_show_multiple"));
			if (result) {
				var count = Number(result.trim());
				if (!isNaN(count) && count > 0) {
					config_crud({ basic_mode_delay: count });
				}
			}
		}, use_other);
	} else {

		// sighter_enabled deprecated 13-Oct-2018; do things the SOLO way

		toolbar.new_text(div, S("MATCH_SIGHTERS")); // 0, 1, ....

		var sighter_modes = [{ count: 0, text: "---" }, { count: 1, text: "1" },
		{ count: 2, text: "2" },
		{ count: 3, text: "3" },
		{ count: -1, text: S("MATCH_SIGHTERS_UNLIMITED") }];

		var use_other = true; // whether sighter count is 'other'

		for (var mode_i in sighter_modes) {
			var mode = sighter_modes[mode_i];

			var item = toolbar.new_button(div, mode.text, function () {
				config_crud({ sighter_count: this.arg });
			}, g_config.sighter_count == mode.count);
			item[0].arg = mode.count;

			if (g_config.sighter_count == mode.count) use_other = false;
		}

		// fix when value is invalid
		if (use_other && !(g_config.sighter_count >= 1)) {
			config_crud({ sighter_count: 2 }); // set to default
			use_other = false;
		}

		// other button
		toolbar.new_button(div, (use_other) ? ("(" + g_config.sighter_count + ")") : ("(...)"), function () {
			var result = prompt(S("MATCH_SIGHTERS_OTHER_PROMPT"));
			if (result) {
				var count = Number(result.trim());
				if (!isNaN(count) && count > 0) {
					config_crud({ sighter_count: count });
				}
			}
		}, use_other);

		toolbar.new_button(div, S("MATCH_SIGHTERS_CONVERTIBLE"), function () {
			config_crud({ sighter_convertible: !g_config.sighter_convertible });
		}, g_config.sighter_convertible);

		// end sighters

		div.append("<br>");
		// option_total_score deprecated 13-Oct-2018; do things the SOLO way
		toolbar.new_text(div, S("MATCH_SHOTS"));

		var shots_modes = [{ count: 0, text: "--" }, { count: 5, text: "5" },
		{ count: 7, text: "7" },
		{ count: 10, text: "10" },
		{ count: 15, text: "15" },
		{ count: 20, text: "20" }];
		if (toolbar_military.is_mil()) {
			var shots_modes = [{ count: 0, text: "--" },
			{ count: 3, text: "3" },
			{ count: 5, text: "5" },
			{ count: 10, text: "10" }];
		}

		var use_other = true; // whether sighter count is 'other'

		for (var shots_i in shots_modes) {
			var mode = shots_modes[shots_i];

			var item = toolbar.new_button(div, mode.text, function () {
				config_crud({ shots_mode: this.arg });
			}, g_config.shots_mode == mode.count);
			item[0].arg = mode.count;

			if (g_config.shots_mode == mode.count) use_other = false;
		}

		// fix when value is invalid
		if (use_other && !(g_config.shots_mode >= 1)) {
			config_crud({ shots_mode: 10 }); // set to default
			use_other = false;
		}

		// other button
		toolbar.new_button(div, (use_other) ? ("(" + g_config.shots_mode + ")") : ("(...)"), function () {
			var result = prompt(S("MATCH_SHOTS_OTHER_PROMPT"));
			if (result) {
				var count = Number(result.trim());
				if (!isNaN(count) && count > 0) {
					config_crud({ shots_mode: count });
				}
			}
		}, use_other);
	}
}

toolbar_match.draw_shotDelayButtons = function (div) {
	toolbar.new_text(div, S("match_shot_delay"));

	toolbar.new_button(div, S("match_fclass_only"), function () { // todo
		config_crud({ shot_display_delay_FClass_only: !g_config.shot_display_delay_FClass_only });
	}, g_config.shot_display_delay_FClass_only);

	var delays_modes = [{ count: 0, text: "--" }, { count: 5, text: "5s" },
	{ count: 7, text: "7s" },
	{ count: 10, text: "10s" }];

	var use_other = true; // whether sighter count is 'other'

	for (var delays_i in delays_modes) {
		var mode = delays_modes[delays_i];

		var item = toolbar.new_button(div, mode.text, function () {
			config_crud({ shot_display_delay: this.arg });
		}, g_config.shot_display_delay == mode.count);
		item[0].arg = mode.count;

		if (g_config.shot_display_delay == mode.count) use_other = false;
	}

	// fix when value is invalid
	if (use_other && !(g_config.shot_display_delay >= 1)) {
		config_crud({ shot_display_delay: 7 }); // set to default
		use_other = false;
	}

	// other button
	toolbar.new_button(div, (use_other) ? ("(" + g_config.shot_display_delay + ")") : ("(...)"), function () {
		var result = prompt(S("match_shot_delay_prompt"));
		if (result) {
			var count = Number(result.trim());
			if (!isNaN(count) && count > 0) {
				config_crud({ shot_display_delay: count });
			}
		}
	}, use_other);
}



function is_shot_display_speed() {
	return !!g_config.shot_display_speed;
}

toolbar_match.draw_shotListOptionButtons = function (div) {

	toolbar.new_text(div, "Shotlist options");

	toolbar.new_button(div, "speed", function () { // todo
		config_crud({ shot_display_speed: !g_config.shot_display_speed });
	}, g_config.shot_display_speed);
// todo... maybe more granular control here, e.g. converting sighters or saving strings?
}