#!/bin/sh

# 
# $Author: dmc $
# $Revision: 2980 $
# $Date: 2021-08-18 14:10:10 -0300 (Wed, 18 Aug 2021) $
# $HeadURL: http://support2.silvermountaintargets.com/svn/smt/smtv2-lodi/tsolo_recover.sh $
#

S7_FSOLO_ip=192.168.0.7
alias sshQFSOLO='ssh  -y -i /www/smtv2/homedir/ssh-dir/id_rsa_smtservice.dropbear root@${S7_FSOLO_ip} 2>/dev/null'


echo
echo TSOLO recovery tool, checking server type...


if wget -O - http://${S7_FSOLO_ip}/serialno_password > /dev/null 2>&1
then
	echo
	echo "Server type is S7.  Checking S7's DHCP leases for any connected TSOLOC2 devices..."
	echo
	devicesfound=0
	sshQFSOLO cat /tmp/dhcp.leases | while read dhcpline
	do
		# 1623050344 f8:d1:11:0f:55:e5 192.168.0.161 blackie-desktop *
		set -- junk $dhcpline; shift # handle empty
		mac=$2
		ip=$3
		case $mac in
		  "c4:"*) echo Attempting update on TSOLO, MAC=$mac, IP=$ip
			devicesfound=1
		    ./SOLO_C2_sw_update.sh $ip
		    echo
		    ;;
		esac
	done

	if [ 0 == $devicesfound ]; then
		echo no connected TSOLO-C2 devices found
	fi


	echo
	echo FINISHED
	exit 0

	sshQFSOLO uci show wireless | grep radio
	sshQFSOLO id
	echo "done"
	exit 0
else
	echo
	echo 'we are NOT an S7; FSOLO not found *** or not updated with latest firmware ***'
	exit 3
fi

exit 0



